// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, seem,
    hasProp = {}.hasOwnProperty;

  seem = require('seem');

  pkg = require('../../package.json');

  this.name = pkg.name + ":middleware:carrier:setup";

  debug = (require('tangible'))(this.name);

  this.config = seem(function*() {
    var base, k, name, p, profile, ref, ref1, ref2, ref3, ref4, v;
    this.cfg.profiles = {};
    this.cfg.acls = {};
    this.cfg.host_data = this.cfg.host != null ? (debug("Retrieving data for " + this.cfg.host), (yield this.cfg.prov.get("host:" + this.cfg.host)["catch"]((function(_this) {
      return function(error) {
        _this.debug.ops("Host " + _this.cfg.host + ": " + error);
        return {};
      };
    })(this)))) : (this.debug.dev('No cfg.host'), {});
    if ((base = this.cfg).sip_profiles == null) {
      base.sip_profiles = (ref = this.cfg.host_data.sip_profiles) != null ? ref : {};
    }
    debug('Configuring SIP Profiles', this.cfg.sip_profiles);
    ref1 = this.cfg.sip_profiles;
    for (name in ref1) {
      if (!hasProp.call(ref1, name)) continue;
      profile = ref1[name];
      p = {
        local_ip: profile.ingress_sip_ip,
        socket_port: (ref2 = this.cfg.port) != null ? ref2 : 5702
      };
      for (k in profile) {
        if (!hasProp.call(profile, k)) continue;
        v = profile[k];
        p[k] = v;
      }
      this.cfg.profiles[name] = p;
      this.cfg.acls[name + "-ingress"] = (ref3 = profile.ingress_acl) != null ? ref3 : [];
      this.cfg.acls[name + "-egress"] = (ref4 = profile.egress_acl) != null ? ref4 : [];
    }
    return null;
  });

  this.server_pre = seem(function*() {
    var base, ref;
    this.cfg.host_data = this.cfg.host != null ? (debug("Retrieving data for " + this.cfg.host), (yield this.cfg.prov.get("host:" + this.cfg.host)["catch"]((function(_this) {
      return function(error) {
        debug("Host " + _this.cfg.host + ": " + error);
        return {};
      };
    })(this)))) : (debug('No cfg.host'), {});
    if ((base = this.cfg).sip_profiles == null) {
      base.sip_profiles = (ref = this.cfg.host_data.sip_profiles) != null ? ref : {};
    }
    debug('Configuring SIP Profiles', this.cfg.sip_profiles);
    return null;
  });

  this.include = seem(function*() {
    var Reference, base, base1, base2, base3, base4, m, our_dialplan, ref, ref1, reference_in, sip_params, sip_profile_carrier, sip_profile_client;
    if ((base = this.session).context == null) {
      base.context = this.data['Channel-Context'];
    }
    this.debug('>>>> New call', this.session.context, this.data);
    if (!(m = (ref = this.session.context) != null ? ref.match(/^(\S+)-(ingress|egress|transfer|handled)(?:-(\S+))?$/) : void 0)) {
      this.debug.dev('Malformed context', this.session.context);
      return this.respond('500 Malformed context');
    }
    this.session.profile = m[1];
    this.direction(m[2]);
    if ((base1 = this.session).reference == null) {
      base1.reference = m[3];
    }
    if ((base2 = this.session).reference == null) {
      base2.reference = this.req.variable('session_reference');
    }
    reference_in = (function(_this) {
      return function(name) {
        var base3, ref1;
        if (m = (ref1 = _this.req.variable(name)) != null ? ref1.match(/xref[=:]([\w-]+)/) : void 0) {
          return (base3 = _this.session).reference != null ? base3.reference : base3.reference = m[1];
        }
      };
    })(this);
    reference_in('sip_from_params');
    reference_in('sip_to_params');
    reference_in('sip_req_params');
    reference_in('sip_contact_params');
    reference_in('sip_referred_by_params');
    reference_in('sip_h_X-FS-Refer-Params');
    Reference = this.cfg.Reference;
    this.reference = new Reference(this.session.reference);
    this.session.reference = this.reference.id;
    if ((yield this.reference.get_dev_logger())) {
      this.session.dev_logger = true;
    }
    this.notify({
      state: 'incoming-call-carrier-side'
    });
    sip_profile_client = pkg.name + "-" + this.session.profile + "-egress";
    sip_profile_carrier = pkg.name + "-" + this.session.profile + "-ingress";
    this.session.sip_profile = this.req.variable('sip_profile');
    if (this.session.direction === 'ingress') {
      if ((base3 = this.session).sip_profile == null) {
        base3.sip_profile = sip_profile_client;
      }
    } else {
      if ((base4 = this.session).sip_profile == null) {
        base4.sip_profile = sip_profile_carrier;
      }
    }
    this.session.transfer = false;
    this.session.handled_transfer_context = [this.session.profile, 'handled', this.session.reference].join('-');
    if (this.session.direction === 'handled') {
      this.session.transfer = true;
      this.direction('handled');
    }
    this.session.profile_data = this.cfg.sip_profiles[this.session.profile];
    sip_params = "xref=" + this.session.reference;
    our_dialplan = "inline:'socket:127.0.0.1:" + ((ref1 = this.cfg.port) != null ? ref1 : 5702) + " async full'";
    yield this.set({
      session_reference: this.session.reference
    });
    yield this["export"]({
      session_reference: this.session.reference,
      sip_redirect_profile: this.session.profile,
      sip_redirect_context: this.session.default_transfer_context,
      sip_redirect_dialplan: our_dialplan,
      sip_redirect_contact_params: sip_params,
      sip_invite_params: sip_params,
      sip_invite_to_params: sip_params,
      sip_invite_contact_params: sip_params,
      sip_invite_from_params: sip_params
    });
    this.debug('Ready', {
      reference: this.session.reference,
      call: this.call.uuid,
      session: this.session._id,
      context: this.session.context,
      direction: this.session.direction,
      destination: this.destination,
      source: this.source,
      transfer: this.session.transfer,
      profile: this.session.profile,
      sip_profile: this.session.sip_profile
    });
  });

}).call(this);
