// Generated by CoffeeScript 1.12.7
(function() {
  var Moment, debug, pkg, seem,
    hasProp = {}.hasOwnProperty;

  pkg = require('../package.json');

  this.name = pkg.name + ":middleware:cdr";

  debug = (require('tangible'))(this.name);

  seem = require('seem');

  Moment = require('moment-timezone');

  this.include = seem(function*() {
    var call_data;
    call_data = {};
    call_data.start_time = Date.now();
    call_data.uuid = this.call.uuid;
    call_data.session = this.session._id;
    call_data.source = this.source;
    call_data.destination = this.destination;
    this.call.once('cleanup_linger').then(seem((function(_this) {
      return function*() {
        _this.debug("CDR: Linger: pausing");
        yield _this.sleep(4000);
        _this.debug("CDR: Linger: exit");
        return (yield _this.call.exit()["catch"](function(error) {
          return _this.debug.dev("exit: " + error);
        }));
      };
    })(this)));
    yield this.call.linger();
    if (!((this.statistics != null) && (this.notify != null))) {
      this.debug.dev('Error: Improper environment');
      return;
    }
    this.statistics.add('incoming-calls');
    yield this.call.event_json('CHANNEL_HANGUP_COMPLETE');
    this.call.once('CHANNEL_HANGUP_COMPLETE').then((function(_this) {
      return function(res) {
        var cdr_report, data, float, integer, k, ref, ref1, ref2, ref3, uepoch, v;
        _this.debug("Channel Hangup Complete");
        data = res.body;
        integer = function(x) {
          var v;
          if (isNaN(v = parseInt(x, 10))) {
            return null;
          }
          return v;
        };
        float = function(x) {
          var v;
          if (isNaN(v = parseFloat(x))) {
            return null;
          }
          return v;
        };
        uepoch = function(x) {
          var v;
          if (isNaN(v = parseInt(x, 10))) {
            return null;
          }
          return Math.floor(v / 1000);
        };
        cdr_report = {
          direction: _this.session.cdr_direction,
          emergency: (ref = _this.session.destination_emergency) != null ? ref : null,
          onnet: (ref1 = _this.session.destination_onnet) != null ? ref1 : null,
          duration: integer(data.variable_mduration),
          billable: integer(data.variable_billmsec),
          progress: integer(data.variable_progressmsec),
          answer: integer(data.variable_answermsec),
          wait: integer(data.variable_waitmsec),
          held: integer(data.variable_hold_accum_ms),
          progress_media: integer(data.variable_progress_mediamsec),
          flow_bill: integer(data.variable_flow_billmsec),
          start_time: uepoch(data.variable_start_uepoch),
          answer_time: uepoch(data.variable_answer_uepoch),
          bridge_time: uepoch(data.variable_bridge_uepoch),
          progress_time: uepoch(data.variable_progress_uepoch),
          hold_times: (ref2 = (ref3 = data.variable_hold_events) != null ? ref3.match(/(\d+)/g).map(uepoch) : void 0) != null ? ref2 : [],
          end_time: uepoch(data.variable_end_uepoch),
          audio_in_packets: integer(data.rtp_audio_in_packet_count),
          audio_out_packets: integer(data.rtp_audio_out_packet_count),
          skip_packets: integer(data.variable_rtp_audio_in_skip_packet_count),
          jitter_packets: integer(data.variable_rtp_audio_in_jitter_packet_count),
          jitter_min_variance: float(data.variable_rtp_audio_in_jitter_min_variance),
          jitter_max_variance: float(data.variable_rtp_audio_in_jitter_max_variance),
          in_mos: float(data.variable_rtp_audio_in_mos)
        };
        for (k in cdr_report) {
          if (!hasProp.call(cdr_report, k)) continue;
          v = cdr_report[k];
          switch (k) {
            case 'direction':
              _this.statistics.add("direction-" + v, cdr_report.billable);
              break;
            case 'emergency':
              if (v) {
                _this.statistics.add("emergency");
              }
              break;
            case 'onnet':
              if (v) {
                _this.statistics.add("onnet");
              }
              break;
            case 'hold_times':
            case 'end_time':
            case 'start_time':
            case 'answer_time':
            case 'bridge_time':
            case 'progress_time':
              false;
              break;
            default:
              _this.statistics.add(k, v);
          }
        }
        _this.session.cdr_report = cdr_report;
        _this.call.emit('cdr_report', cdr_report);
        call_data.end_time = Date.now();
        if (_this.session.timezone != null) {
          call_data.timezone = _this.session.timezone;
          call_data.tz_start_time = Moment(call_data.start_time).tz(_this.session.timezone).format();
          call_data.tz_end_time = Moment(call_data.end_time).tz(_this.session.timezone).format();
        }
        _this.notify({
          state: 'end',
          call_data: call_data,
          cdr_report: cdr_report
        });
        return _this.debug("CDR: Channel Hangup Complete", cdr_report);
      };
    })(this))["catch"]((function(_this) {
      return function(error) {
        var ref;
        return _this.debug("On CHANNEL_HANGUP_COMPLETE, " + ((ref = error.stack) != null ? ref : error));
      };
    })(this));
    this.debug('Ready');
  });

}).call(this);
