// Generated by CoffeeScript 1.12.7
(function() {
  var Holidays, Moment, chain, commands, debug, get_list, global_egress, global_ingress, ingress_modules, is_blacklisted, is_suspicious, is_whitelisted, local_egress, local_ingress, max_menu_depth, menu_conference_module, pattern, request, run, seem, serialize,
    slice = [].slice,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  this.name = 'huge-play:middleware:client:commands';

  debug = (require('tangible'))(this.name);

  Moment = require('moment-timezone');

  Holidays = require('date-holidays');

  request = require('superagent');

  run = require('flat-ornament');

  seem = require('seem');

  serialize = require('useful-wind-serialize');

  max_menu_depth = 42;

  local_ingress = seem(function*() {
    var interesting_number, list, list_id, pid;
    list = (yield this.validate_local_number());
    pid = this.req.header('P-Asserted-Identity');
    interesting_number = pid != null ? url.parse(pid).auth : this.source;
    list_id = "list:" + list + "@" + interesting_number;
    this.debug('local_ingress', list, interesting_number);
    return list_id;
  });

  local_egress = function() {
    var caller, interesting_number, list, list_id, ref;
    caller = (ref = this.session.asserted) != null ? ref : this.source;
    list = caller + "@" + this.session.number_domain;
    interesting_number = this.destination;
    list_id = "list:" + list + "@" + interesting_number;
    this.debug('local_egress', list, interesting_number);
    return list_id;
  };

  global_ingress = function() {
    var list_id;
    if (!((this.session.ccnq_to_164 != null) && (this.session.ccnq_from_164 != null))) {
      return false;
    }
    return list_id = "list:" + this.session.ccnq_to_e164 + "@" + this.session.ccnq_from_e164;
  };

  global_egress = function() {
    var list_id;
    if (!((this.session.ccnq_to_164 != null) && (this.session.ccnq_from_164 != null))) {
      return false;
    }
    return list_id = "list:" + this.session.ccnq_from_e164 + "@" + this.session.ccnq_to_e164;
  };

  get_list = seem(function*(list_id) {
    var list;
    if (list_id) {
      list = (yield this.cfg.prov.get(list_id)["catch"](function() {
        return {};
      }));
      if (list.disabled) {
        return null;
      } else {
        return list;
      }
    } else {
      return null;
    }
  });

  is_blacklisted = function(list) {
    return list != null ? list.blacklist : void 0;
  };

  is_whitelisted = function(list) {
    return list != null ? list.whitelist : void 0;
  };

  is_suspicious = function(list) {
    return list != null ? list.suspicious : void 0;
  };

  chain = function(test, selector) {
    return seem(function*() {
      var list, list_id;
      list_id = (yield selector.call(this));
      list = (yield get_list.call(this, list_id));
      return test.call(this, list);
    });
  };

  menu_conference_module = {
    name: 'menu_conference_module',
    include: function() {
      var item, m, number, ref, ref1;
      if (this.session.dialplan !== 'centrex') {
        return;
      }
      if (!(m = this.destination.match(/^82(\d+)$/))) {
        return;
      }
      number = parseInt(m[1], 10);
      item = (ref = this.session.number_domain_data) != null ? (ref1 = ref.conferences) != null ? ref1[number] : void 0 : void 0;
      if (item != null) {
        if (item.short_name == null) {
          item.short_name = "conf-" + number;
        }
        if (item.full_name == null) {
          item.full_name = this.session.number_domain + "-" + item.short_name;
        }
        this.session.conf = item;
        this.direction('conf');
      }
    }
  };

  ingress_modules = [];

  module.exports = commands = {
    stop: function() {
      this.debug('stop');
      return 'over';
    },
    accept: function() {
      this.debug('accept');
      return 'over';
    },
    hangup: seem(function*() {
      this.debug('hangup');
      yield this.action('hangup');
      this.direction('hangup');
      return 'over';
    }),
    send: seem(function*(destination) {
      this.debug('send');
      this.session.direction = 'ingress';
      this.destination = destination;
      yield serialize.modules(ingress_modules, this, 'include');
      return 'over';
    }),
    menu_send: seem(function*() {
      this.debug('menu_send');
      if (this.menu == null) {
        return false;
      }
      yield this.menu.expect();
      this.debug('menu_send', this.menu.value);
      this.session.direction = 'ingress';
      this.destination = this.menu.value;
      yield serialize.modules([menu_conference_module].concat(slice.call(ingress_modules)), this, 'include');
      return 'over';
    }),
    reject: seem(function*() {
      this.debug('reject');
      yield this.respond('486 Decline');
      return 'over';
    }),
    announce: seem(function*(message) {
      this.debug('announce', message);
      yield this.action('answer');
      yield this.action('playback', this.cfg.provisioning + "/config%3Avoice_prompts/" + message + ".wav");
      yield this.action('hangup');
      return 'over';
    }),
    voicemail: function() {
      this.debug('voicemail');
      this.direction('voicemail');
      return 'over';
    },
    forward: function(destination) {
      this.debug('forward', destination);
      this.session.reason = 'unspecified';
      this.session.destination = destination;
      this.direction('forward');
      return 'over';
    },
    email: function(recipient, template) {
      this.debug('email', recipient, template);
      return true;
    },
    play: seem(function*(file) {
      var url;
      this.debug('play', file);
      url = this.prompt.uri('prov', 'ignore', this.session.number_domain_data._id, file);
      yield this.action('answer');
      yield this.unset('playback_terminators');
      yield this.action('playback', url);
      return true;
    }),
    message: seem(function*(number) {
      var file, ref, ref1, ref2, url;
      this.debug('message', number);
      if (!((ref = this.session.number_domain_data) != null ? (ref1 = ref.msg) != null ? (ref2 = ref1[number]) != null ? ref2.active : void 0 : void 0 : void 0)) {
        return true;
      }
      file = "msg-" + number + ".mp3";
      url = this.prompt.uri('prov', 'ignore', this.session.number_domain_data._id, file);
      yield this.action('answer');
      yield this.unset('playback_terminators');
      yield this.action('playback', url);
      return true;
    }),
    menu_play: seem(function*(file) {
      var url;
      this.debug('menu_play', file);
      url = this.prompt.uri('prov', 'ignore', this.session.number_domain_data._id, file);
      yield this.action('answer');
      yield this.dtmf.playback(url);
      return true;
    }),
    music: function(file) {
      this.session.music = this.prompt.uri('prov', 'ignore', this.session.number_domain_data._id, file);
      return true;
    },
    ringback: function(file) {
      this.session.ringback = this.prompt.uri('prov', 'ignore', this.session.number_domain_data._id, file);
      return true;
    },
    wait: seem(function*(ms) {
      this.debug('wait', ms);
      yield this.dtmf.playback("silence_stream://" + ms);
      this.debug('wait over', ms);
      return true;
    }),
    record: function(name) {
      return this.record_call(name);
    },
    source: function(source) {
      this.debug('source', source);
      return pattern(source, this.source);
    },
    source_e164: function(source) {
      this.debug('source_e164', source);
      return pattern(source, this.session.ccnq_from_e164);
    },
    destination: function(destination) {
      this.debug('destination', destination);
      return pattern(destination, this.destination);
    },
    destination_e164: function(destination) {
      this.debug('destination_e164', destination);
      return pattern(destination, this.session.ccnq_to_e164);
    },
    weekdays: function() {
      var days, now, ref;
      days = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      this.debug.apply(this, ['weekdays'].concat(slice.call(days)));
      now = Moment();
      if (this.session.timezone != null) {
        now = now.tz(this.session.timezone);
      }
      return ref = now.day(), indexOf.call(days, ref) >= 0;
    },
    time: function(start, end) {
      var now;
      this.debug('time', start, end);
      now = Moment();
      if (this.session.timezone != null) {
        now = now.tz(this.session.timezone);
      }
      now = now.format('HH:mm');
      if (start <= end) {
        return (start <= now && now <= end);
      } else {
        return start <= now || now <= end;
      }
    },
    user_tag: function(tag) {
      this.user_tag(tag);
      this.notify({
        state: 'menu',
        user_tag: tag
      });
      return true;
    },
    alert_info: seem(function*(alert_info) {
      yield this["export"]({
        alert_info: alert_info
      });
      this.session.alert_info = alert_info;
      return true;
    }),
    clear_call_center_tags: seem(function*() {
      yield this.clear_call_center_tags();
      return true;
    }),
    clear_user_tags: seem(function*() {
      yield this.clear_user_tags();
      return true;
    }),
    required_skill: seem(function*(skill) {
      yield this.tag("skill:" + skill);
      return true;
    }),
    priority: seem(function*(priority) {
      yield this.tag("priority:" + priority);
      return true;
    }),
    queue: seem(function*(queue) {
      yield this.tag("queue:" + queue);
      return true;
    }),
    broadcast: seem(function*() {
      yield this.tag('broadcast');
      return true;
    }),
    has_tag: function(tag) {
      return this.has_tag(tag);
    },
    has_user_tag: function(tag) {
      return this.has_user_tag(tag);
    },
    agent_skill: seem(function*(skill) {
      if (typeof skill !== 'string') {
        return false;
      }
      yield this.agent.add_tag("skill:" + skill);
      return true;
    }),
    agent_queue: seem(function*(queue) {
      if (typeof queue !== 'string') {
        return false;
      }
      yield this.agent.add_tag("queue:" + queue);
      return true;
    }),
    agent_broadcast: seem(function*() {
      yield this.agent.add_tag("broadcast");
      return true;
    }),
    in_calendars: function() {
      var calendar, calendars, dates, domain_calendars, hd, i, len, m, now, now_date, ref, ref1, ref2, res;
      calendars = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      this.debug('calendars', calendars);
      if (calendars.length === 1 && ((ref = typeof calendars[0]) !== 'string' && ref !== 'number')) {
        calendars = calendars[0];
      }
      domain_calendars = (ref1 = (ref2 = this.session.number_domain_data) != null ? ref2.calendars : void 0) != null ? ref1 : {};
      now = Moment();
      if (this.session.timezone != null) {
        now = now.tz(this.session.timezone);
      }
      now_date = new Date(now);
      now = now.format('YYYY-MM-DD');
      for (i = 0, len = calendars.length; i < len; i++) {
        calendar = calendars[i];
        switch (false) {
          case !(m = calendar.match(/^_holidays_(.*)$/)):
            hd = new Holidays();
            hd.init.apply(hd, m[1].split('_'));
            res = hd.isHoliday(now_date);
            if ((res != null ? res.type : void 0) === 'public') {
              return true;
            }
            break;
          case calendar !== '_holidays':
            if (this.session.country) {
              hd = new Holidays(this.session.country.toUpperCase());
              res = hd.isHoliday(now_date);
              if ((res != null ? res.type : void 0) === 'public') {
                return true;
              }
            }
            break;
          default:
            if (domain_calendars[calendar] != null) {
              dates = domain_calendars[calendar].dates;
              if ((dates != null) && indexOf.call(dates, now) >= 0) {
                return true;
              }
            }
        }
      }
      return false;
    },
    anonymous: function() {
      this.debug('anonymous');
      return this.session.caller_privacy;
    },
    webhook: seem(function*(uri) {
      var body;
      this.debug('webhook');
      try {
        body = (yield request.post(uri).send({
          tags: (yield this.reference.tags()),
          ccnq_from_e164: this.session.ccnq_from_e164,
          ccnq_to_e164: this.session.ccnq_to_e164,
          _in: this._in()
        })).body;
        if (body != null) {
          yield this.user_tags(body.tags);
        }
        return true;
      } catch (error) {
        this.debug('webhook: error');
        return false;
      }
    }),
    busy: function() {
      this.debug('busy');
      return this.session.reason === 'user-busy';
    },
    unavailable: function() {
      this.debug('unavailable');
      return this.session.reason === 'unavailable';
    },
    'no-answer': function() {
      this.debug('no-anwer');
      return this.session.reason === 'no-answer';
    },
    failed: function() {
      this.debug('failed');
      return this.session.call_failed;
    },
    answered: function() {
      this.debug('answered');
      if (this.session.was_connected) {
        return true;
      } else {
        return false;
      }
    },
    picked: function() {
      this.debug('picked');
      if (this.session.was_picked) {
        return true;
      } else {
        return false;
      }
    },
    transferred: function() {
      this.debug('transferred');
      if (this.session.was_transferred) {
        return true;
      } else {
        return false;
      }
    },
    caller_blacklist: chain(is_blacklisted, local_ingress),
    called_blacklist: chain(is_blacklisted, local_egress),
    caller_e164_blacklist: chain(is_blacklisted, global_ingress),
    called_e164_blacklist: chain(is_blacklisted, global_egress),
    caller_whitelist: chain(is_whitelisted, local_ingress),
    called_whitelist: chain(is_whitelisted, local_egress),
    caller_e164_whitelist: chain(is_whitelisted, global_ingress),
    called_e164_whitelist: chain(is_whitelisted, global_egress),
    caller_suspicious: chain(is_suspicious, local_ingress),
    called_suspicious: chain(is_suspicious, local_egress),
    caller_e164_suspicious: chain(is_suspicious, global_ingress),
    called_e164_suspicious: chain(is_suspicious, global_egress),
    menu: seem(function*(min, max, itd, fin) {
      if (min == null) {
        min = 1;
      }
      if (max == null) {
        max = min;
      }
      this.debug('menu_start');
      yield this.action('answer');
      this.dtmf.clear();
      this.menu = {
        expect: seem((function(_this) {
          return function*() {
            var base;
            return (base = _this.menu).value != null ? base.value : base.value = (yield _this.dtmf.expect(min, max, itd, fin));
          };
        })(this))
      };
      return true;
    }),
    menu_on: seem(function*(choice) {
      choice = "" + choice;
      this.debug('menu_on', choice);
      if (this.menu == null) {
        return false;
      }
      yield this.menu.expect();
      this.debug('menu_on', choice, this.menu.value);
      return this.menu.value === choice;
    }),
    goto_menu: seem(function*(number) {
      var item, items, type;
      this.debug('goto_menu', number);
      type = 'menu';
      items = this.session.number_domain_data.menus;
      if (items == null) {
        this.debug.csr("Number domain has no data for " + type + ".");
        return;
      }
      if (!items.hasOwnProperty(number)) {
        this.debug.dev("No property " + number + " in " + type + " of " + this.session.number_domain);
        return;
      }
      item = items[number];
      if (item == null) {
        this.debug.csr("Number domain as no data " + number + " for " + type + ".");
        return;
      }
      this.session[type] = item;
      this.direction(type);
      this.debug("Using " + type + " " + number, item);
      if (this.menu_depth == null) {
        this.menu_depth = 0;
      }
      this.menu_depth++;
      if (this.menu_depth > max_menu_depth) {
        return false;
      }
      yield this.sleep(200);
      yield run.call(this, item, this.ornaments_commands);
      return 'over';
    })
  };

  pattern = function(p, n) {
    var r;
    if (!p.match(/^(\d|\?|\.|\.\.|\.\.\.|…)+$/)) {
      debug('invalid pattern', p);
      return false;
    }
    p = p.replace(/\.\.|\.\.\.|…/g, '\\d*').replace(/\?|\./g, '\\d');
    r = new RegExp("^" + p + "$");
    debug('pattern', p, r);
    return n.match(r);
  };

}).call(this);
