// Generated by CoffeeScript 1.12.7
(function() {
  var pkg, seem;

  pkg = require('../../../package');

  this.name = pkg.name + ":middleware:client:egress:fifo";

  seem = require('seem');

  this.include = seem(function*() {
    var ACTION_CONF_ROUTE, ACTION_EAVESDROP, ACTION_FIFO_ROUTE, ACTION_FIFO_VOICEMAIL, ACTION_INTERCEPT, ACTION_MENU_ROUTE, ACTION_MONITOR, ACTION_MSG_ACTIVATE, ACTION_MSG_DEACTIVATE, ACTION_MSG_LISTEN, ACTION_MSG_RECORD, ACTION_QUEUER_LEAVE, ACTION_QUEUER_LOGIN, ACTION_QUEUER_LOGOUT, ACTION_QUEUER_OFFHOOK, action, agent, agent_name, agent_tags, base, base1, base2, base3, doc, failed, fifo, file, get, inbound_uuid, m, number, outbound_uuid, ref, ref1, route, uri, uuid;
    if (this.session.direction !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    if (this.session.forwarding === true) {
      return;
    }
    if (!this.session.number_domain) {
      this.debug('No number domain');
      return;
    }
    if (!(m = this.destination.match(/^(80\d\d|81\d|82|83|84|87|88)(\d*)$/))) {
      return;
    }
    action = m[1];
    if (m[2] === '') {
      number = null;
    } else {
      number = parseInt(m[2], 10);
    }
    ACTION_FIFO_ROUTE = '810';
    ACTION_QUEUER_LOGIN = '811';
    ACTION_QUEUER_LEAVE = '812';
    ACTION_QUEUER_OFFHOOK = '813';
    ACTION_FIFO_VOICEMAIL = '817';
    ACTION_QUEUER_LOGOUT = '819';
    ACTION_CONF_ROUTE = '82';
    ACTION_MENU_ROUTE = '83';
    ACTION_INTERCEPT = '84';
    ACTION_MONITOR = '87';
    ACTION_EAVESDROP = '88';
    ACTION_MSG_RECORD = '8011';
    ACTION_MSG_ACTIVATE = '8012';
    ACTION_MSG_DEACTIVATE = '8013';
    ACTION_MSG_LISTEN = '8014';
    this.debug('Routing', action, number);
    if ((base = this.session).number_domain_data == null) {
      base.number_domain_data = (yield this.cfg.prov.get("number_domain:" + this.session.number_domain)["catch"]((function(_this) {
        return function(error) {
          _this.debug.csr("number_domain " + number_domain + ": " + error);
          return {};
        };
      })(this)));
    }
    get = (function(_this) {
      return function(name, type) {
        var item, items;
        items = _this.session.number_domain_data[name];
        if (items == null) {
          _this.debug.csr("Number domain has no " + name + ".");
          return;
        }
        if (!((number != null) && items.hasOwnProperty(number))) {
          _this.debug.dev("No property " + number + " in " + name + " of " + _this.session.number_domain);
          return;
        }
        item = items[number];
        if (item != null) {
          if (item.short_name == null) {
            item.short_name = type + "-" + number;
          }
          if (type === 'conf') {
            if (item.full_name == null) {
              item.full_name = _this.session.number_domain + "-" + item.short_name;
            }
          } else {
            if (item.full_name == null) {
              item.full_name = item.short_name + "@" + _this.session.number_domain;
            }
          }
        }
        return item;
      };
    })(this);
    route = (function(_this) {
      return function(name, type) {
        var item;
        item = get(name, type);
        if (item == null) {
          return false;
        }
        _this.session[type] = item;
        _this.direction(type);
        return true;
      };
    })(this);
    agent_tags = (function(_this) {
      return function() {
        var broadcast, i, j, len, len1, queue, queues, ref, skill, skills, tags;
        tags = [];
        ref = _this.session.number, skills = ref.skills, queues = ref.queues, broadcast = ref.broadcast;
        if (skills != null) {
          for (i = 0, len = skills.length; i < len; i++) {
            skill = skills[i];
            tags.push("skill:" + skill);
          }
        }
        if (queues != null) {
          for (j = 0, len1 = queues.length; j < len1; j++) {
            queue = queues[j];
            tags.push("queue:" + queue);
          }
        }
        if (broadcast) {
          tags.push('broadcast');
        }
        return tags;
      };
    })(this);
    agent = (ref = this.session.agent) != null ? ref : this.source + "@" + this.session.number_domain;
    agent_name = (ref1 = this.session.agent_name) != null ? ref1 : this.source;
    failed = (function(_this) {
      return function() {
        _this.debug('Failed');
        _this.direction('failed');
        return _this.action('hangup');
      };
    })(this);
    switch (action) {
      case ACTION_CONF_ROUTE:
        this.debug('Conf: call');
        if (!route('conferences', 'conf')) {
          return failed();
        }
        break;
      case ACTION_MENU_ROUTE:
        this.debug('Menu: call');
        if (!route('menus', 'menu')) {
          return failed();
        }
        break;
      case ACTION_FIFO_ROUTE:
        this.debug('FIFO: call');
        if (!route('fifos', 'fifo')) {
          return failed();
        }
        break;
      case ACTION_INTERCEPT:
        if (number == null) {
          return failed();
        }
        uuid = (yield this.local_redis.get("inbound_call:" + number + "@" + this.session.number_domain));
        this.debug('Intercept', uuid);
        if (uuid == null) {
          return failed();
        }
        yield this.set({
          intercept_unbridged_only: true
        });
        yield this.action('intercept', uuid);
        this.direction('intercepted');
        break;
      case ACTION_EAVESDROP:
        if (number == null) {
          return failed();
        }
        inbound_uuid = (yield this.local_redis.get("inbound:" + number + "@" + this.session.number_domain));
        outbound_uuid = (yield this.local_redis.get("outbound:" + number + "@" + this.session.number_domain));
        this.debug('Eavesdrop', inbound_uuid, outbound_uuid);
        switch (false) {
          case inbound_uuid == null:
            uuid = inbound_uuid;
            yield this.set({
              eavesdrop_bridge_aleg: true,
              eavesdrop_bridge_bleg: true,
              eavesdrop_whisper_aleg: false,
              eavesdrop_whisper_bleg: false
            });
            break;
          case outbound_uuid == null:
            uuid = outbound_uuid;
            yield this.set({
              eavesdrop_bridge_aleg: true,
              eavesdrop_bridge_bleg: true,
              eavesdrop_whisper_aleg: false,
              eavesdrop_whisper_bleg: false
            });
            break;
          default:
            return failed();
        }
        yield this.set({
          eavesdrop_indicate_failed: 'silence_stream://125',
          eavesdrop_indicate_new: 'silence_stream://125',
          eavesdrop_indicate_idle: 'silence_stream://125',
          eavesdrop_enable_dtmf: true
        });
        yield this.action('answer');
        yield this.sleep(200);
        yield this.action('eavesdrop', uuid);
        this.direction('eavesdropping');
        break;
      case ACTION_MONITOR:
        if (number == null) {
          return failed();
        }
        inbound_uuid = (yield this.local_redis.get("inbound:" + number + "@" + this.session.number_domain));
        outbound_uuid = (yield this.local_redis.get("outbound:" + number + "@" + this.session.number_domain));
        this.debug('Monitor', inbound_uuid, outbound_uuid);
        switch (false) {
          case inbound_uuid == null:
            uuid = inbound_uuid;
            yield this.set({
              eavesdrop_bridge_aleg: true,
              eavesdrop_bridge_bleg: true,
              eavesdrop_whisper_aleg: true,
              eavesdrop_whisper_bleg: false
            });
            break;
          case outbound_uuid == null:
            uuid = outbound_uuid;
            yield this.set({
              eavesdrop_bridge_aleg: true,
              eavesdrop_bridge_bleg: true,
              eavesdrop_whisper_aleg: false,
              eavesdrop_whisper_bleg: true
            });
            break;
          default:
            return failed();
        }
        yield this.set({
          eavesdrop_indicate_failed: 'tone_stream://%(125,0,300)',
          eavesdrop_indicate_new: 'tone_stream://%(125,0,600);%(125,0,450)',
          eavesdrop_indicate_idle: 'tone_stream://%(125,125,450);%(125,0,450)',
          eavesdrop_enable_dtmf: true
        });
        yield this.action('answer');
        yield this.sleep(200);
        yield this.cfg.api("uuid_broadcast " + uuid + " gentones::%(125,0,450)");
        yield this.action('eavesdrop', uuid);
        this.direction('eavesdropping');
        break;
      case ACTION_QUEUER_LOGIN:
        this.debug('Queuer: log in');
        fifo = get('fifos', 'fifo');
        yield this.action('answer');
        yield this.sleep(2000);
        if ((base1 = this.session).timezone == null) {
          base1.timezone = this.session.number.timezone;
        }
        yield this.queuer_login(agent, agent_name, fifo, agent_tags(), this.session.number.login_ornaments);
        yield this.action('gentones', '%(100,20,300);%(100,20,450);%(100,20,600)');
        yield this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_QUEUER_OFFHOOK:
        this.debug('Queuer: off-hook agent');
        fifo = get('fifos', 'fifo');
        yield this.action('answer');
        yield this.sleep(2000);
        yield this.set({
          hangup_after_bridge: false,
          park_after_bridge: true
        });
        yield this.queuer_offhook(agent, agent_name, this.call, fifo, agent_tags());
        this.direction('queuer-offhook');
        break;
      case ACTION_QUEUER_LEAVE:
        this.debug('Queuer: leave queue');
        fifo = get('fifos', 'fifo');
        if (fifo == null) {
          return failed();
        }
        yield this.action('answer');
        yield this.sleep(2000);
        yield this.queuer_leave(agent, fifo);
        yield this.action('gentones', '%(100,20,600);%(100,20,450);%(100,20,600)');
        yield this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_QUEUER_LOGOUT:
        this.debug('Queuer: log out');
        fifo = get('fifos', 'fifo');
        yield this.action('answer');
        yield this.sleep(2000);
        yield this.queuer_logout(agent, fifo);
        yield this.action('gentones', '%(100,20,600);%(100,20,450);%(100,20,300)');
        yield this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_FIFO_VOICEMAIL:
        this.debug('FIFO: voicemail');
        fifo = get('fifos', 'fifo');
        if ((fifo != null ? fifo.user_database : void 0) == null) {
          return failed();
        }
        this.destination = 'inbox';
        this.source = 'user-database';
        this.session.voicemail_user_database = fifo.user_database;
        this.session.voicemail_user_id = fifo.full_name;
        return this.direction('voicemail');
      case ACTION_MSG_DEACTIVATE:
        this.debug('deactivate message');
        yield this.action('answer');
        yield this.sleep(2000);
        doc = this.session.number_domain_data;
        if (doc.msg == null) {
          doc.msg = {};
        }
        if ((base2 = doc.msg)[number] == null) {
          base2[number] = {};
        }
        doc.msg[number].active = false;
        yield this.cfg.master_push(doc);
        yield this.action('gentones', '%(200,20,600);%(200,20,450)');
        return this.direction('completed');
      case ACTION_MSG_ACTIVATE:
        this.debug('activate message');
        yield this.action('answer');
        yield this.sleep(2000);
        doc = this.session.number_domain_data;
        if (doc.msg == null) {
          doc.msg = {};
        }
        if ((base3 = doc.msg)[number] == null) {
          base3[number] = {};
        }
        doc.msg[number].active = true;
        yield this.cfg.master_push(doc);
        yield this.action('gentones', '%(200,20,450);%(200,20,600)');
        return this.direction('completed');
      case ACTION_MSG_RECORD:
        this.debug('record message');
        yield this.action('answer');
        yield this.sleep(2000);
        doc = this.session.number_domain_data;
        file = "msg-" + number + ".mp3";
        uri = this.prompt.uri('master-prov', 'ignore', doc._id, file, doc._rev);
        yield this.prompt.record(uri);
        yield this.action('hangup');
        return this.direction('completed');
      case ACTION_MSG_LISTEN:
        this.debug('listen to message');
        yield this.action('answer');
        yield this.sleep(2000);
        doc = this.session.number_domain_data;
        file = "msg-" + number + ".mp3";
        uri = this.prompt.uri('prov', 'ignore', doc._id, file);
        yield this.action('playback', uri);
        yield this.action('hangup');
        return this.direction('completed');
      default:
        this.debug('Unknown action', action);
        return failed();
    }
  });

}).call(this);
