// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, translate_source;

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:egress:national-CH";

  debug = (require('tangible'))(this.name);

  translate_source = function(source) {
    var $;
    switch (false) {
      case !($ = source.match(/^(0|\+41)([1-9][0-9]{8})$/)):
        return "41" + $[2];
      case !($ = source.match(/^(00|\+)([2-9][0-9]*)$/)):
        return $[2];
      default:
        debug("Cannot translate source " + source);
        return null;
    }
  };

  this.include = function() {
    var entry, i, len, m, new_asserted, new_source, patterns;
    if (this.session.direction !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'national') {
      return;
    }
    if (this.session.country !== 'ch') {
      return;
    }
    this.debug('source', this.source);
    new_source = translate_source(this.source);
    if (new_source != null) {
      this.session.ccnq_from_e164 = new_source;
    }
    if (this.session.asserted != null) {
      new_asserted = translate_source(this.session.asserted);
      if (new_asserted != null) {
        this.session.asserted = new_asserted;
      }
    }
    patterns = [
      {
        match: /^(0|\+41)([123456789][0-9]{8})$/,
        now: function($) {
          return "41" + $[2];
        }
      }, {
        match: /^(1[0-9]{2,5})$/,
        now: function($) {
          return "41_" + $[1];
        }
      }, {
        match: /^(00|\+)([0-9]*)$/,
        now: function($) {
          return $[2];
        }
      }
    ];
    for (i = 0, len = patterns.length; i < len; i++) {
      entry = patterns[i];
      m = this.destination.match(entry.match);
      if (m != null) {
        this.session.ccnq_to_e164 = entry.now(m);
        this.debug('Found', {
          to_e164: this.session.ccnq_to_e164
        });
        return;
      }
    }
    return this.debug('None found', {
      destination: this.destination
    });
  };

}).call(this);
