// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, translate_source;

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:egress:national-FR";

  debug = (require('tangible'))(this.name);

  translate_source = function(source) {
    var $;
    switch (false) {
      case !($ = source.match(/^(0|\+33)([123456789][0-9]{8})$/)):
        return "33" + $[2];
      case !($ = source.match(/^(00|\+)([2-9][0-9]*)$/)):
        return $[2];
      default:
        debug("Cannot translate source " + source);
        return null;
    }
  };

  this.include = function() {
    var entry, i, len, m, new_asserted, new_source, patterns;
    if (this.session.direction !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'national') {
      return;
    }
    if (this.session.country !== 'fr') {
      return;
    }
    this.debug('source', this.source);
    new_source = translate_source(this.source);
    if (new_source != null) {
      this.session.ccnq_from_e164 = new_source;
    }
    if (this.session.asserted != null) {
      new_asserted = translate_source(this.session.asserted);
      if (new_asserted != null) {
        this.session.asserted = new_asserted;
      }
    }
    patterns = [
      {
        match: /^(0|\+33)(26[29].*)$/,
        now: function($) {
          return "262" + $[2];
        }
      }, {
        match: /^(0|\+33)(639.*)$/,
        now: function($) {
          return "262" + $[2];
        }
      }, {
        match: /^(0|\+33)(69[01].*)$/,
        now: function($) {
          return "590" + $[2];
        }
      }, {
        match: /^(0|\+33)(69[23].*)$/,
        now: function($) {
          return "262" + $[2];
        }
      }, {
        match: /^(0|\+33)(694.*)$/,
        now: function($) {
          return "594" + $[2];
        }
      }, {
        match: /^(0|\+33)(69[67].*)$/,
        now: function($) {
          return "596" + $[2];
        }
      }, {
        match: /^(0|\+33)(590.*)$/,
        now: function($) {
          return "590" + $[2];
        }
      }, {
        match: /^(0|\+33)(262.*)$/,
        now: function($) {
          return "262" + $[2];
        }
      }, {
        match: /^(0|\+33)(594.*)$/,
        now: function($) {
          return "594" + $[2];
        }
      }, {
        match: /^(0|\+33)(596.*)$/,
        now: function($) {
          return "596" + $[2];
        }
      }, {
        match: /^(0|\+33)(508.*)$/,
        now: function($) {
          return $[2];
        }
      }, {
        match: /^(0|\+33)(876[01].*|976[018])$/,
        now: function($) {
          return "590" + $[2];
        }
      }, {
        match: /^(0|\+33)(876[23].*|976[239])$/,
        now: function($) {
          return "262" + $2;
        }
      }, {
        match: /^(0|\+33)(876[4].*|976[45])$/,
        now: function($) {
          return "594" + $[2];
        }
      }, {
        match: /^(0|\+33)(876[67].*|976[67])$/,
        now: function($) {
          return "596" + $[2];
        }
      }, {
        match: /^(0|\+33)([123456789][0-9]{8})$/,
        now: function($) {
          return "33" + $[2];
        }
      }, {
        match: /^(1[0-9]{1,5}|3[0-9]{3})$/,
        now: function($) {
          return "33_" + $[1];
        }
      }, {
        match: /^(00|\+)([0-9]*)$/,
        now: function($) {
          return $[2];
        }
      }
    ];
    for (i = 0, len = patterns.length; i < len; i++) {
      entry = patterns[i];
      m = this.destination.match(entry.match);
      if (m != null) {
        this.session.ccnq_to_e164 = entry.now(m);
        this.debug('Found', {
          to_e164: this.session.ccnq_to_e164
        });
        return;
      }
    }
    return this.debug('None found', {
      destination: this.destination
    });
  };

}).call(this);
