// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, qs, second, seem, sleep,
    hasProp = {}.hasOwnProperty;

  pkg = require('../../package');

  this.name = pkg.name + ":middleware:client:fifo";

  debug = (require('tangible'))(this.name);

  seem = require('seem');

  qs = require('querystring');

  this.description = 'Handles routing to a given queue/ACD/hunt-group.';

  sleep = function(timeout) {
    return new Promise(function(resolve) {
      return setTimeout(resolve, timeout);
    });
  };

  second = 1000;

  this.include = seem(function*() {
    var announce_uri, attempt_overflow, base, call, call_is_answered, call_tags, cause, causes, data, fifo, fifo_progress_timeout, fifo_timeout, fifo_uri, fn, i, id, j, k, l, leg_delay_start, leg_progress_timeout, leg_timeout, len, len1, len2, m, member, music_uri, queuer, recipient, recipients, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref_tags, res, skill, sofias, v, xfer;
    this.debug('Starting');
    if (this.session.direction !== 'fifo') {
      return;
    }
    fifo_uri = (function(_this) {
      return function(id, name) {
        return _this.prompt.uri('prov', 'prov', id, name);
      };
    })(this);
    if (this.session.fifo == null) {
      this.debug('Missing FIFO data');
      return;
    }
    fifo = this.session.fifo;
    this.notify({
      state: 'fifo',
      fifo: fifo.full_name
    });
    this.debug('Answer');
    yield this.action('answer');
    call_is_answered = true;
    yield this["export"]({
      t38_passthru: false,
      sip_wait_for_aleg_ack: !call_is_answered
    });
    id = "number_domain:" + this.session.number_domain;
    this.debug('Send to FIFO');
    yield this.set({
      continue_on_fail: true
    });
    if (this.session.ringback != null) {
      announce_uri = this.session.ringback;
    }
    if (this.session.announce != null) {
      announce_uri = this.session.announce;
    }
    if (fifo.announce != null) {
      announce_uri = fifo_uri(id, fifo.announce);
    }
    if (announce_uri != null) {
      yield this.set({
        ringback: announce_uri
      });
    }
    if (this.session.music != null) {
      music_uri = this.session.music;
    }
    if (fifo.music != null) {
      music_uri = fifo_uri(id, fifo.music);
    }
    if (music_uri != null) {
      yield this["export"]({
        hold_music: music_uri
      });
    }
    if (this.session.ccnq_from_e164 != null) {
      this.source = "+" + this.session.ccnq_from_e164;
    }
    if (fifo.tags != null) {
      yield this.user_tags(fifo.tags);
    }
    if (fifo.required_skills != null) {
      ref = fifo.required_skills;
      for (j = 0, len = ref.length; j < len; j++) {
        skill = ref[j];
        yield this.tag("skill:" + skill);
      }
    }
    if (typeof fifo.queue === 'string') {
      yield this.tag("queue:" + fifo.queue);
    }
    if (fifo.priority != null) {
      yield this.tag("priority:" + fifo.priority);
    }
    if (fifo.broadcast) {
      yield this.tag('broadcast');
    }
    if (fifo.queue) {
      this.notify({
        state: 'queue',
        name: fifo.full_name,
        queue: fifo.queue
      });
      queuer = this.cfg.queuer;
      call = this.queuer_call;
      ref_tags = (yield this.reference.tags());
      yield call.set_tags(ref_tags);
      yield call.add_tag("number_domain:" + this.session.number_domain);
      if (music_uri != null) {
        yield call.set_music(music_uri);
      }
      if (announce_uri != null) {
        this.action('endless_playback', announce_uri);
      }
      yield call.set_remote_number(this.source);
      if (this.session.alert_info != null) {
        yield call.set_alert_info(this.session.alert_info);
      }
      yield call.clear();
      yield queuer.queue_ingress_call(call);
      call_tags = ref_tags.filter(function(tag) {
        return tag.match(/^queue:/);
      });
      if (call_tags.length === 0) {
        this.debug('no queues, no overflow');
        return;
      }
      attempt_overflow = seem((function(_this) {
        return function*(suffix) {
          var l, len1, ok, tag;
          _this.debug('attempt overflow', call_tags, suffix);
          yield call.load();
          if ((yield queuer.ingress_pool.has(call))) {
            ok = false;
            for (l = 0, len1 = call_tags.length; l < len1; l++) {
              tag = call_tags[l];
              if (!((yield call.has_tag(tag)))) {
                continue;
              }
              yield call.add_tag(tag + ":" + suffix);
              ok = true;
            }
            return ok;
          } else {
            return false;
          }
        };
      })(this));
      if (!attempt_overflow('overflow')) {
        return;
      }
      yield sleep(30 * second);
      if (!attempt_overflow('overflow:30s')) {
        return;
      }
      yield sleep(30 * second);
      if (!attempt_overflow('overflow:60s')) {
        return;
      }
      return;
    }
    this.notify({
      state: 'group',
      name: fifo.full_name
    });
    sofias = [];
    fifo_timeout = (ref1 = fifo.timeout) != null ? ref1 : 0;
    fifo_progress_timeout = (ref2 = fifo.progress_timeout) != null ? ref2 : 4;
    recipients = [];
    ref3 = fifo.members;
    for (i = l = 0, len1 = ref3.length; l < len1; i = ++l) {
      member = ref3[i];
      if ('string' === typeof member) {
        recipient = member;
        leg_delay_start = i * 5;
        leg_progress_timeout = 4;
        leg_timeout = 60;
      } else {
        recipient = member.recipient;
        leg_delay_start = (ref4 = member.delay) != null ? ref4 : 0;
        leg_progress_timeout = (ref5 = member.progress_timeout) != null ? ref5 : fifo_progress_timeout;
        leg_timeout = (ref6 = member.timeout) != null ? ref6 : fifo_timeout;
      }
      recipients.push(recipient + "@" + this.session.number_domain);
      sofias.push((yield this.sofia_string(recipient, [
        (function() {
          var ref7, results;
          ref7 = {
            t38_passthru: false,
            leg_delay_start: leg_delay_start,
            leg_progress_timeout: leg_progress_timeout,
            leg_timeout: leg_timeout
          };
          results = [];
          for (k in ref7) {
            if (!hasProp.call(ref7, k)) continue;
            v = ref7[k];
            results.push(k + "=" + v);
          }
          return results;
        })()
      ])));
    }
    this.debug('bridge', sofias);
    res = (yield this.action('bridge', sofias.join(',')));
    data = res.body;
    if ((base = this.session).bridge_data == null) {
      base.bridge_data = [];
    }
    this.session.bridge_data.push(data);
    this.debug('Returned from FIFO', data);
    causes = (ref7 = data.variable_originate_causes) != null ? ref7.map(function(str) {
      return str.split(':')[1];
    }) : void 0;
    ref8 = causes != null ? causes : [];
    fn = (function(_this) {
      return function(cause, agent) {
        switch (cause) {
          case 'NONE':
            _this.notify({
              state: 'hunt-bridging',
              agent: agent
            });
            return _this.notify({
              state: 'answered',
              agent: agent
            });
          case 'NO_ROUTE_DESTINATION':
            return false;
          default:
            _this.notify({
              state: 'hunt-bridging',
              agent: agent
            });
            return _this.notify({
              event: 'missed',
              agent: agent
            });
        }
      };
    })(this);
    for (i = m = 0, len2 = ref8.length; m < len2; i = ++m) {
      cause = ref8[i];
      fn(cause, recipient[i]);
    }
    xfer = data.variable_transfer_history;
    if (xfer != null) {
      this.debug('Call was transferred', xfer);
      return;
    }
    cause = data.variable_originate_disposition;
    this.debug("FIFO returned with cause " + cause);
    if (cause === 'NORMAL_CALL_CLEARING' || cause === 'SUCCESS' || cause === 'NORMAL_CLEARING') {
      this.debug("Successful call when routing FIFO " + fifo.full_name + " through " + (sofias.join(',')));
      yield this.action('hangup');
      return;
    }
    if (cause === 'ORIGINATOR_CANCEL') {
      return;
    }
    if (fifo.voicemail != null) {
      this.debug('Send to voicemail');
      this.destination = fifo.voicemail;
      this.direction('voicemail');
      yield this.validate_local_number();
      return;
    }
    if (fifo.user_database != null) {
      this.debug('Send to voicemail (user-database)');
      this.destination = 'user-database';
      this.session.voicemail_user_database = fifo.user_database;
      this.session.voicemail_user_id = fifo.full_name;
      this.direction('voicemail');
      return;
    }
    this.debug('Hangup');
    return (yield this.action('hangup'));
  });

}).call(this);
