// Generated by CoffeeScript 1.12.7
(function() {
  var pkg, seem;

  pkg = require('../../../package');

  this.name = pkg.name + ":middleware:client:ingress:fifo";

  seem = require('seem');

  this.description = 'Maps an ingress call (which already went through the `local-number` middleware) to a FIFO/conference/menu.';

  this.include = seem(function*() {
    var base, base1, base2, conf_name, item, items, m, music_uri, number, number_domain, ref, ref1, ref2, ref3, ref4, ref5, ref6, type;
    if (this.session.direction !== 'ingress') {
      return;
    }
    music_uri = (function(_this) {
      return function(doc) {
        if (doc.music == null) {
          return null;
        }
        return _this.prompt.uri('prov', 'prov', doc._id, doc.music);
      };
    })(this);
    this.debug("Testing for FIFO/conference/menu in " + this.destination);
    m = this.destination.match(/^(fifo|conf|menu|localconf)-(.+)$/);
    if (m == null) {
      return;
    }
    type = m[1];
    number = m[2];
    if (number == null) {
      return;
    }
    if (type === 'localconf' && (this.session.number_domain_data == null)) {
      conf_name = number;
      m = conf_name.match(/^(.+)-([^-]+)$/);
      if (m == null) {
        this.debug.dev("localconf " + m + " is not properly formatted");
        return;
      }
      type = 'conf';
      number_domain = m[1];
      number = m[2];
      this.session.number_domain = number_domain;
      this.session.number_domain_data = (yield this.cfg.prov.get("number_domain:" + number_domain)["catch"]((function(_this) {
        return function(error) {
          _this.debug.dev("number_domain " + number_domain + ": " + error);
          return null;
        };
      })(this)));
      yield this.user_tags((ref = this.session.number_domain_data) != null ? ref.tags : void 0);
      if (((ref1 = this.session.number_domain_data) != null ? ref1.timezone : void 0) != null) {
        if ((base = this.session).timezone == null) {
          base.timezone = (ref2 = this.session.number_domain_data) != null ? ref2.timezone : void 0;
        }
      }
      if (((ref3 = this.session.number_domain_data) != null ? ref3.music : void 0) != null) {
        if ((base1 = this.session).music == null) {
          base1.music = music_uri(this.session.number_domain_data);
        }
      }
      if (((ref4 = this.session.number_domain_data) != null ? ref4.dialplan : void 0) != null) {
        if ((base2 = this.session).dialplan == null) {
          base2.dialplan = this.session.number_domain_data.dialplan;
        }
      }
    }
    if (this.session.number_domain_data == null) {
      this.debug.dev('Missing number_domain_data');
      return;
    }
    yield this.reference.add_in(this.session.number_domain_data._id);
    items = (function() {
      switch (type) {
        case 'fifo':
          return this.session.number_domain_data.fifos;
        case 'conf':
          return this.session.number_domain_data.conferences;
        case 'menu':
          return this.session.number_domain_data.menus;
        default:
          return null;
      }
    }).call(this);
    if (items == null) {
      this.debug.csr("Number domain has no data for " + type + ".");
      return;
    }
    if (!items.hasOwnProperty(number)) {
      this.debug.dev("No property " + number + " in " + type + " of " + this.session.number_domain + ".");
      return;
    }
    item = items[number];
    if (item == null) {
      this.debug.csr("Number domain has no data " + number + " for " + type + ".");
      return;
    }
    if (item.short_name == null) {
      item.short_name = type + "-" + number;
    }
    if (type === 'conf') {
      if (item.full_name == null) {
        item.full_name = this.session.number_domain + "-" + item.short_name;
      }
    } else {
      if (item.full_name == null) {
        item.full_name = item.short_name + "@" + this.session.number_domain;
      }
    }
    this.session[type] = item;
    this.direction(type);
    this.report({
      state: type,
      name: item.full_name,
      number: number != null ? number : null,
      number_domain: (ref5 = (ref6 = this.session.number_domain_data) != null ? ref6._id : void 0) != null ? ref5 : null
    });
    this.debug("Using " + type + " " + number, item);
  });

}).call(this);
