// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, seem;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:ingress:local-number";

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    var base, music_uri, number, number_domain, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7;
    if (this.session.direction !== 'ingress') {
      return;
    }
    music_uri = (function(_this) {
      return function(doc) {
        if (doc.music == null) {
          return null;
        }
        return _this.prompt.uri('prov', 'prov', doc._id, doc.music);
      };
    })(this);
    if (((ref = this.session.e164_number) != null ? ref.local_number : void 0) == null) {
      return;
    }
    yield this.reference.add_in("number:" + this.session.e164_number.local_number);
    this.debug('Using local_number', this.session.e164_number.local_number);
    ref1 = this.session.e164_number.local_number.split('@'), number = ref1[0], number_domain = ref1[1];
    this.destination = number;
    this.session.number_domain = number_domain;
    this.session.number_domain_data = (yield this.cfg.prov.get("number_domain:" + number_domain)["catch"]((function(_this) {
      return function(error) {
        var ref2;
        _this.debug("number_domain " + number_domain + ": " + ((ref2 = error.stack) != null ? ref2 : error));
        return {};
      };
    })(this)));
    yield this.reference.add_in(this.session.number_domain_data._id);
    yield this.user_tags(this.session.number_domain_data.tags);
    this.session.timezone = (ref2 = (ref3 = this.session.number_domain_data) != null ? ref3.timezone : void 0) != null ? ref2 : this.session.e164_number.timezone;
    this.session.music = music_uri(this.session.number_domain_data);
    if ((base = this.session).music == null) {
      base.music = music_uri(this.session.e164_number);
    }
    this.session.dialplan = (ref4 = (ref5 = this.session.number_domain_data) != null ? ref5.dialplan : void 0) != null ? ref4 : this.session.e164_number.dialplan;
    this.session.country = (ref6 = (ref7 = this.session.number_domain_data) != null ? ref7.country : void 0) != null ? ref6 : this.session.e164_number.country;
    if (this.session.country != null) {
      this.session.country = this.session.country.toLowerCase();
    }
    this.report({
      state: 'local-number',
      number: this.session.e164_number.local_number,
      number_domain: this.session.number_domain_data._id
    });
    this.debug('OK');
  });

}).call(this);
