// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg;

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:ingress:national-FR";

  debug = (require('tangible'))(this.name);

  this.include = function() {
    var $;
    if (this.session.direction !== 'ingress') {
      return;
    }
    if (this.session.dialplan !== 'e164') {
      return;
    }
    debug('Ready', {
      destination: this.destination,
      source: this.source
    });
    switch (false) {
      case !($ = this.destination.match(/^33([1-9][0-9]+)$/)):
        this.session.ccnq_to_e164 = this.destination;
        this.destination = "0" + $[1];
        this.session.country = 'fr';
        break;
      default:
        return;
    }
    switch (false) {
      case !($ = this.source.match(/^3389|^089/)):
        debug('Calling number is blocked per ARCEP 05-1085 2.b.1.iii page 14');
        this.direction('trash');
        return this.respond('484');
      case !($ = this.source.match(/^33([0-9]+)$/)):
        this.session.ccnq_from_e164 = this.source;
        this.source = "0" + $[1];
        break;
      case !($ = this.source.match(/^([1-9][0-9]+)$/)):
        this.session.ccnq_from_e164 = this.source;
        this.source = "00" + $[1];
        break;
      case this.source !== 'anonymous':
        debug('Source is anonymous');
        break;
      default:
        debug('Invalid source', this.source);
        return this.respond('484 Invalid source');
    }
    this.session.dialplan = 'national';
    debug('OK', {
      source: this.source,
      destination: this.destination,
      diaplan: this.session.dialplan,
      country: this.session.country
    });
  };

}).call(this);
