// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, seem, set_params;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:ingress:post-forward";

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    var base, dst_number, parameters, to_uri;
    if (this.session.direction !== 'ingress') {
      return;
    }
    if (this.session.forwarding !== true) {
      return;
    }
    this.debug('Ready', {
      dialplan: this.session.dialplan,
      country: this.session.country,
      destination: this.destination,
      number_domain: this.session.number_domain
    });
    if (this.session.dialplan === 'e164') {
      return this.respond('484');
    }
    dst_number = (yield this.validate_local_number());
    yield set_params.call(this);
    parameters = [];
    to_uri = "sip:" + this.session.endpoint_name;
    if (!to_uri.match(/@/)) {
      to_uri = "sip:" + this.destination + "@" + this.cfg.ingress_target;
    }
    if (this.session.number.endpoint_via != null) {
      parameters.push("sip_network_destination=" + this.session.number.endpoint_via);
    }
    if ((base = this.session).initial_destinations == null) {
      base.initial_destinations = [
        {
          parameters: parameters,
          to_uri: to_uri
        }
      ];
    }
    if (this.session.dev_logger) {
      yield this.reference.set_dev_logger(true);
    }
    this.debug('Done.');
  });

  set_params = seem(function*() {
    var dlg_timeout, ref;
    this.debug('set_params');
    dlg_timeout = (ref = this.session.number.dialog_timer) != null ? ref : 28000;
    this.debug('schedule hangup');
    yield this.action('sched_hangup', "+" + dlg_timeout);
    yield this["export"]({
      'sip_h_X-En': this.session.endpoint_name
    });
    this.debug('set_params: done.');
  });

}).call(this);
