// Generated by CoffeeScript 1.12.7
(function() {
  var assert, debug, default_music, default_ringback, pkg, seem, set_params, tones, url;

  seem = require('seem');

  pkg = require('../../../package.json');

  assert = require('assert');

  this.name = pkg.name + ":middleware:client:ingress:post";

  debug = (require('tangible'))(this.name);

  url = require('url');

  tones = require('../tones');

  default_ringback = tones.fr.ringback;

  default_music = 'silence';

  this.include = seem(function*() {
    var base, base1, base2, base3, base4, caller, dst_number, fn, i, len, list, list_id, name, parameters, pid, ref, to_uri;
    if (this.session.direction !== 'ingress') {
      return;
    }
    this.debug('Ready', {
      dialplan: this.session.dialplan,
      country: this.session.country,
      destination: this.destination,
      number_domain: this.session.number_domain
    });
    assert(this.session.number_domain != null, 'Missing number_domain');
    if (this.session.dialplan === 'e164') {
      return this.respond('484');
    }
    dst_number = (yield this.validate_local_number());
    if (dst_number == null) {
      this.debug('Number not found');
      return;
    }
    if (this.session.number.reject_anonymous) {
      if (this.session.caller_privacy) {
        if (this.session.number.reject_anonymous_to_voicemail) {
          this.debug('reject anonymous: send to voicemail');
          this.direction('voicemail');
          return;
        }
        this.debug('reject anonymous');
        this.notify({
          state: 'reject-anonymous'
        });
        yield this.action('answer');
        yield this.action('playback', this.cfg.provisioning + "/config%3Avoice_prompts/reject-anonymous.wav");
        return this.action('hangup');
      }
    }
    if (this.session.number.use_blacklist || this.session.number.use_whitelist) {
      pid = this.req.header('P-Asserted-Identity');
      caller = pid != null ? url.parse(pid).auth : this.source;
      list_id = "list:" + dst_number + "@" + caller;
      this.debug("Number " + dst_number + ", requesting caller " + caller + " list " + list_id);
      list = (yield this.cfg.prov.get(list_id)["catch"](function() {
        return {};
      }));
      if (!list.disabled) {
        if (this.session.number.use_blacklist && list.blacklist) {
          this.notify({
            state: 'blacklisted'
          });
          if (this.session.number.list_to_voicemail) {
            this.direction('voicemail');
            return;
          }
          return this.respond('486 Decline (blacklisted)');
        }
        if (this.session.number.use_whitelist && !list.whitelist) {
          this.notify({
            state: 'not whitelisted'
          });
          if (this.session.number.list_to_voicemail) {
            this.direction('voicemail');
            return;
          }
          return this.respond('486 Decline (not whitelisted)');
        }
      }
    }
    this.debug('ringback', this.session.ringback, this.session.number.custom_ringback);
    if (this.session.number.custom_ringback === true) {
      if ((base = this.session).ringback == null) {
        base.ringback = [this.cfg.userdb_base_uri, this.session.number.user_database, 'voicemail_settings', 'ringback.wav'].join('/');
      }
    }
    if (typeof this.session.number.custom_ringback === 'string') {
      if ((base1 = this.session).ringback == null) {
        base1.ringback = [this.cfg.userdb_base_uri, this.session.number.user_database, 'voicemail_settings', this.session.number.custom_ringback].join('/');
      }
    }
    if (this.session.number.custom_music === true) {
      if ((base2 = this.session).music == null) {
        base2.music = [this.cfg.userdb_base_uri, this.session.number.user_database, 'voicemail_settings', 'music.wav'].join('/');
      }
    }
    if (typeof this.session.number.custom_music === 'string') {
      if ((base3 = this.session).music == null) {
        base3.music = [this.cfg.userdb_base_uri, this.session.number.user_database, 'voicemail_settings', this.session.number.custom_music].join('/');
      }
    }
    yield set_params.call(this);
    this.session.cf_active = false;
    ref = ['cfa', 'cfb', 'cfnr', 'cfda'];
    fn = (function(_this) {
      return function(name) {
        var n, p, v;
        if (_this.session.number[name + "_enabled"] === false) {
          return;
        }
        v = _this.session[name + "_voicemail"] = _this.session.number[name + "_voicemail"];
        n = _this.session[name + "_number"] = _this.session.number[name + "_number"];
        p = _this.session[name] = _this.session.number[name];
        _this.session.cf_active = _this.session.cf_active || (v != null) || (n != null) || (p != null);
        return _this.session[name + "_voicemail_number"] = _this.destination;
      };
    })(this);
    for (i = 0, len = ref.length; i < len; i++) {
      name = ref[i];
      fn(name);
    }
    this.debug('CFA?');
    this.session.reason = 'unconditional';
    if (this.session.cfa_voicemail) {
      this.debug('cfa:voicemail');
      this.notify({
        state: 'cfa:voicemail'
      });
      this.destination = this.session.cfa_voicemail_number;
      this.direction('voicemail');
      return;
    }
    if (this.session.cfa_number != null) {
      this.debug('cfa:forward');
      this.notify({
        state: 'cfa:forward'
      });
      this.session.destination = this.session.cfa_number;
      this.direction('forward');
      return;
    }
    if (this.session.cfa != null) {
      this.debug('cfa:fallback');
      this.notify({
        state: 'cfa:fallback'
      });
      this.session.initial_destinations = [
        {
          to_uri: this.session.cfa
        }
      ];
      return;
    }
    this.session.reason = null;
    this.debug('Ringback');
    if (this.session.number.custom_ringback) {
      if (this.cfg.answer_for_ringback || this.session.answer_for_ringback) {
        this.debug('answer for ringback');
        yield this.action('answer');
        yield this.set({
          sip_wait_for_aleg_ack: false
        });
        this.session.wait_for_aleg_ack = false;
      } else {
        this.debug('pre_answer for ringback');
        yield this.action('pre_answer');
      }
    } else {
      if (this.session.cf_active || this.cfg.ready_for_ringback || this.session.ready_for_ringback || this.session.number.ring_ready) {
        this.debug('cf_active');
        yield this.action('ring_ready');
      }
    }
    parameters = [];
    to_uri = "sip:" + this.session.endpoint_name;
    if (!to_uri.match(/@/)) {
      to_uri = "sip:" + this.destination + "@" + this.cfg.ingress_target;
    }
    if (this.session.number.endpoint_via != null) {
      to_uri = "sip:" + this.destination + "@" + this.session.number.endpoint_via;
    }
    if ((base4 = this.session).initial_destinations == null) {
      base4.initial_destinations = [
        {
          parameters: parameters,
          to_uri: to_uri
        }
      ];
    }
    this.notify({
      state: 'ingress-call',
      endpoint: this.session.endpoint_name
    });
    if (this.session.dev_logger) {
      yield this.reference.set_dev_logger(true);
    }
    if (this.session.number.record_ingress) {
      this.record_call(this.session.number._id);
    }
    this.debug('Done.');
  });

  set_params = seem(function*() {
    var base, base1, base2, base3, base4, base5, dlg_timeout, fr_inv_timeout, fr_timeout, ref, ref1, ref2, ref3, ref4;
    this.debug('set_params');
    if ((this.session.country != null) && this.session.country in tones) {
      if ((base = this.session).ringback == null) {
        base.ringback = tones[this.session.country].ringback;
      }
      if (this.cfg.use_country_tones_for_music) {
        if ((base1 = this.session).music == null) {
          base1.music = tones.loop(tones[this.session.country].waiting);
        }
      }
    }
    if ((base2 = this.session).ringback == null) {
      base2.ringback = this.cfg.ringback;
    }
    if ((base3 = this.session).ringback == null) {
      base3.ringback = default_ringback;
    }
    if ((base4 = this.session).music == null) {
      base4.music = this.cfg.music;
    }
    if ((base5 = this.session).music == null) {
      base5.music = default_music;
    }
    this.debug('set_params', {
      ringback: this.session.ringback,
      music: this.session.music
    });
    yield this.set({
      ccnq_endpoint: this.session.endpoint_name
    });
    dlg_timeout = (ref = this.session.number.dialog_timer) != null ? ref : 28000;
    fr_inv_timeout = (ref1 = this.session.number.inv_timer) != null ? ref1 : 90;
    fr_timeout = (ref2 = this.session.number.timer) != null ? ref2 : 2;
    this.debug('schedule hangup');
    yield this.action('sched_hangup', "+" + dlg_timeout);
    this.session.cdr_direction = this.session.direction;
    this.debug('set parameters');
    yield this.set({
      ccnq_direction: this.session.direction,
      ccnq_account: this.session.number.account,
      ccnq_profile: this.session.profile,
      ccnq_from_e164: this.session.ccnq_from_e164,
      ccnq_to_e164: this.session.ccnq_to_e164,
      progress_timeout: 18,
      call_timeout: 300,
      sip_contact_user: this.session.ccnq_from_e164,
      effective_caller_id_number: this.source,
      sip_cid_type: 'pid',
      'sip_h_X-En': this.session.endpoint_name,
      'sip_h_X-At': null,
      'sip_h_X-Ex': null,
      'sip_h_X-RH': null,
      'sip_h_X-RP': null,
      'sip_h_X-RR': null,
      'sip_h_X-RT': null,
      'sip_h_X-RU': null,
      ringback: this.session.ringback,
      instant_ringback: false,
      transfer_ringback: this.session.ringback,
      inherit_codec: (ref3 = this.session.inherit_codec) != null ? ref3 : true
    });
    this.debug('export parameters');
    yield this["export"]({
      t38_passthru: true,
      sip_wait_for_aleg_ack: (ref4 = this.session.wait_for_aleg_ack) != null ? ref4 : true,
      'sip_h_X-En': this.session.endpoint_name,
      originate_timeout: fr_inv_timeout,
      bridge_answer_timeout: fr_inv_timeout,
      hold_music: this.session.music
    });
    this.debug('set_params: done.');
  });

}).call(this);
