// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, seem;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:ingress:pre";

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    if (this.session.direction !== 'ingress') {
      return;
    }
    if (this.session.dialplan != null) {
      this.debug('Dialplan already set, skipping');
      return;
    }
    this.debug('Ready');
    this.session.e164_number = (yield this.cfg.prov.get("number:" + this.destination)["catch"](function() {
      return null;
    }));
    if (this.session.e164_number == null) {
      return;
    }
    this.session.dialplan = 'e164';
    this.session.ccnq_from_e164 = this.source;
    this.session.ccnq_to_e164 = this.destination;
    yield this.reference.add_in(this.session.e164_number._id);
    yield this.user_tags(this.session.e164_number.tags);
    if (this.session.e164_number.fs_variables != null) {
      this.debug('Using fs_variables');
      yield this.set(this.session.e164_number.fs_variables);
    }
    if (this.session.e164_number.trace) {
      this.session.dev_logger = true;
    }
    if (this.session.e164_number.voicemail_main) {
      this.debug('Using voicemail_main');
      this.destination = 'main';
      this.session.language = this.session.e164_number.language;
      this.session.number_domain = this.session.e164_number.voicemail_number_domain;
      this.direction('voicemail');
    }
    this.notify({
      state: 'ingress',
      e164_number: this.session.e164_number._id
    });
    this.debug('OK');
  });

}).call(this);
