// Generated by CoffeeScript 1.12.7
(function() {
  var debug, hand, pkg, ref, seem, send;

  seem = require('seem');

  pkg = require('../../../package.json');

  this.name = pkg.name + ":middleware:client:ingress:send";

  ref = (require('tangible'))(this.name), debug = ref.debug, hand = ref.hand;

  this.include = function() {
    var ref1;
    if (this.session.direction !== 'ingress') {
      return;
    }
    this.debug('Ready');
    if (((ref1 = this.session.initial_destinations) != null ? ref1.length : void 0) > 0) {
      return send.call(this, this.session.initial_destinations);
    }
  };

  this.send = send = seem(function*(destinations) {
    var attributes, base, cause, code, data, eavesdrop_key, intercept_key, key, ref1, ref2, ref3, ref4, ref5, res, sofia, when_done;
    key = this.destination + "@" + this.session.number_domain;
    intercept_key = "inbound_call:" + key;
    yield ((ref1 = this.local_redis) != null ? ref1.set(intercept_key, this.call.uuid) : void 0);
    this.session.agent = key;
    eavesdrop_key = "inbound:" + key;
    if (!this.call.closed) {
      this.debug('Set inbound eavesdrop', eavesdrop_key);
      yield ((ref2 = this.local_redis) != null ? ref2.set(eavesdrop_key, this.call.uuid) : void 0);
      attributes = {
        key: key,
        id: this.call.uuid,
        dialplan: this.session.dialplan
      };
      when_done = hand((function(_this) {
        return function*(res) {
          var disposition, ref3, ref4;
          debug('when_done', res);
          disposition = res != null ? (ref3 = res.body) != null ? ref3.variable_transfer_disposition : void 0 : void 0;
          switch (disposition) {
            case 'recv_replace':
              debug('Clear inbound eavesdrop: REFER To', eavesdrop_key, attributes);
              _this.emit('inbound-end', attributes);
              break;
            case 'replaced':
              debug('Clear inbound eavesdrop: Attended Transfer on originating session (accepted transfer)', eavesdrop_key, attributes);
              return;
            case 'bridge':
              debug('Clear inbound eavesdrop: Attended Transfer', eavesdrop_key, attributes);
              _this.emit('inbound-end', attributes);
              break;
            default:
              debug('Clear inbound eavesdrop: end of call', eavesdrop_key, attributes, disposition);
              _this.emit('inbound-end', attributes);
          }
          yield ((ref4 = _this.local_redis) != null ? ref4.del(eavesdrop_key) : void 0);
        };
      })(this));
      yield this.call.event_json('CHANNEL_HANGUP_COMPLETE', 'CHANNEL_BRIDGE', 'CHANNEL_UNBRIDGE');
      this.call.once('CHANNEL_HANGUP_COMPLETE', when_done);
      this.call.on('CHANNEL_BRIDGE', (function(_this) {
        return function(arg) {
          var a_uuid, b_uuid, body;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          debug('CHANNEL_BRIDGE', key, _this.call.uuid, a_uuid, b_uuid);
          return _this.emit('bridge', {
            remote_uuid: b_uuid,
            agent_key: key
          });
        };
      })(this));
      this.call.on('CHANNEL_UNBRIDGE', (function(_this) {
        return function(arg) {
          var a_uuid, b_uuid, body;
          body = arg.body;
          a_uuid = body['Bridge-A-Unique-ID'];
          b_uuid = body['Bridge-B-Unique-ID'];
          debug('CHANNEL_UNBRIDGE', key, _this.call.uuid, a_uuid, b_uuid, body.variable_transfer_disposition, body.variable_endpoint_disposition);
          if (!(body.variable_transfer_disposition === 'replaced' && body.variable_endpoint_disposition === 'ATTENDED_TRANSFER')) {
            return _this.emit('unbridge', {
              remote_uuid: b_uuid,
              agent_key: key
            });
          } else {
            return _this.emit('unbridge', {
              agent_key: key
            });
          }
        };
      })(this));
      this.emit('inbound', attributes);
    }
    sofia = destinations.map((function(_this) {
      return function(arg) {
        var parameters, ref3, to_uri;
        parameters = (ref3 = arg.parameters) != null ? ref3 : [], to_uri = arg.to_uri;
        return "[" + (parameters.join(',')) + "]sofia/" + _this.session.sip_profile + "/" + to_uri;
      };
    })(this));
    this.debug('send', sofia);
    yield this.set({
      continue_on_fail: true
    });
    this.debug('Bridging', sofia);
    this.report({
      state: 'ingress-bridging'
    });
    res = (yield this.action('bridge', sofia.join(',')));
    yield ((ref3 = this.local_redis) != null ? ref3.del(intercept_key) : void 0);
    data = res.body;
    if ((base = this.session).bridge_data == null) {
      base.bridge_data = [];
    }
    this.session.bridge_data.push(data);
    when_done(res);
    cause = data != null ? data.variable_last_bridge_hangup_cause : void 0;
    if (cause == null) {
      cause = data != null ? data.variable_originate_disposition : void 0;
    }
    code = data != null ? (ref4 = data.variable_last_bridge_proto_specific_hangup_cause) != null ? (ref5 = ref4.match(/^sip:(\d+)$/)) != null ? ref5[1] : void 0 : void 0 : void 0;
    if (code == null) {
      code = data != null ? data.variable_sip_term_status : void 0;
    }
    this.debug('Outcome', {
      cause: cause,
      code: code
    });
    this.session.was_connected = cause === 'NORMAL_CALL_CLEARING' || cause === 'NORMAL_CLEARING' || cause === 'SUCCESS';
    this.session.was_transferred = (data.variable_transfer_history != null) || data.variable_endpoint_disposition === 'BLIND_TRANSFER' || data.variable_endpoint_disposition === 'ATTENDED_TRANSFER';
    this.session.was_picked = cause === 'PICKED_OFF';
    if (this.session.was_connected) {
      this.debug("Successful call when routing " + this.destination + " through " + (sofia.join(',')));
      this.notify({
        state: 'answered'
      });
      return;
    }
    if (this.session.was_transferred) {
      this.debug("Transferred call when routing " + this.destination + " through " + (sofia.join(',')));
      this.notify({
        state: 'transferred'
      });
      return;
    }
    this.notify({
      event: 'missed'
    });
    if (this.session.was_picked) {
      this.debug("Picked call when routing " + this.destination + " through " + (sofia.join(',')));
      this.notify({
        state: 'picked',
        from_agent: key
      });
      return;
    }
    if (code === '604') {
      yield this.debug.csr('not-registered', {
        destination: this.destination,
        enpoint: this.session.endpoint_name,
        tried_cfnr: this.session.tried_cfnr
      });
    }
    if (code === '604' && !this.session.tried_cfnr) {
      this.report({
        state: 'not-registered'
      });
      this.session.reason = 'unavailable';
      if (this.session.cfnr_voicemail) {
        this.debug('cfnr:voicemail');
        this.destination = this.session.cfnr_voicemail_number;
        this.direction('voicemail');
        return;
      }
      if (this.session.cfnr_number != null) {
        this.debug('cfnr:forward');
        this.session.destination = this.session.cfnr_number;
        this.direction('forward');
        return;
      }
      if (this.session.cfnr != null) {
        this.debug('cfnr:fallback');
        this.session.tried_cfnr = true;
        return send.call(this, [
          {
            to_uri: this.session.cfnr
          }
        ]);
      }
    }
    if (code === '604') {
      if (this.session.fallback_destinations == null) {
        this.debug('cfnr: no fallback');
        return this.respond('500 No Fallback');
      }
      if (this.session.tried_fallback) {
        this.debug('cfnr: already attempted fallback');
        return this.respond('500 Fallback Failed');
      }
      this.debug('cfnr: fallback on 604');
      this.session.tried_fallback = true;
      return send.call(this, this.session.fallback_destinations);
    }
    if (code === '486' && !this.session.tried_cfb) {
      this.report({
        state: 'user-busy'
      });
      this.session.reason = 'user-busy';
      if (this.session.cfb_voicemail) {
        this.debug('cfb: voicemail');
        this.destination = this.session.cfb_voicemail_number;
        this.direction('voicemail');
        return;
      }
      if (this.session.cfb_number != null) {
        this.debug('cfb:number');
        this.session.destination = this.session.cfb_number;
        this.direction('forward');
        return;
      }
      if (this.session.cfb != null) {
        this.debug('cfb: fallback');
        this.session.tried_cfb = true;
        return send.call(this, [
          {
            to_uri: this.session.cfb
          }
        ]);
      }
    }
    this.debug("Call failed: " + cause + "/" + code + " when routing " + this.destination + " through " + (sofia.join(',')));
    if (!this.session.tried_cfda) {
      this.report({
        state: 'no-answer'
      });
      this.session.reason = 'no-answer';
      if (this.session.cfda_voicemail) {
        this.debug('cfda: voicemail');
        this.destination = this.session.cfda_voicemail_number;
        this.notify({
          state: 'forward-no-answer-to-voicemail'
        });
        this.direction('voicemail');
        return;
      }
      if (this.session.cfda_number != null) {
        this.debug('cfda:number');
        this.session.destination = this.session.cfda_number;
        this.notify({
          state: 'forward-no-answer-to-number'
        });
        this.direction('forward');
        return;
      }
      if (this.session.cfda != null) {
        this.debug('cfda: fallback');
        this.session.tried_cfda = true;
        this.notify({
          state: 'forward-no-answer'
        });
        return send.call(this, [
          {
            to_uri: this.session.cfda
          }
        ]);
      }
    }
    this.debug('Call Failed');
    this.session.call_failed = true;
    this.notify({
      state: 'failed'
    });
  });

}).call(this);
