// Generated by CoffeeScript 1.12.7
(function() {
  var Moment, debug, escape, handler, make_params, now, pkg, seem,
    hasProp = {}.hasOwnProperty;

  seem = require('seem');

  pkg = require('../../package');

  this.name = pkg.name + ":middleware:client:place-call";

  debug = (require('tangible'))(this.name);

  Moment = require('moment-timezone');

  escape = function(v) {
    return ("" + v).replace(',', ',');
  };

  make_params = function(data) {
    var k, v;
    return ((function() {
      var results;
      results = [];
      for (k in data) {
        if (!hasProp.call(data, k)) continue;
        v = data[k];
        results.push(k + "=" + (escape(v)));
      }
      return results;
    })()).join(',');
  };

  now = function(tz) {
    if (tz == null) {
      tz = 'UTC';
    }
    return Moment().tz(tz).format();
  };

  this.handler = handler = function(cfg, ev) {
    var Reference, client_server, context, elected, host, local_server, p, port, profile, ref, ref1, ref2, ref3, ref4, ref5, socket_port, sofia_profile;
    if (cfg.local_redis_client != null) {
      elected = seem(function*(key) {
        var name, winner;
        name = "elected-" + key;
        winner = (yield cfg.local_redis_client.setnx(name, false)["catch"](function() {
          return null;
        }));
        if (winner) {
          yield cfg.local_redis_client.expire(name, 60)["catch"](function() {
            return true;
          });
        } else {
          debug('Lost the election.');
        }
        return winner;
      });
    } else {
      elected = function() {
        return Promise.resolve(true);
      };
    }
    profile = (ref = cfg.session) != null ? ref.profile : void 0;
    if (profile == null) {
      debug.dev('Missing cfg.session.profile, not starting.');
      return;
    }
    sofia_profile = "huge-play-" + profile + "-egress";
    context = profile + "-egress";
    host = cfg.host;
    p = (ref1 = cfg.profiles) != null ? ref1[profile] : void 0;
    if (host && (p != null)) {
      port = (ref2 = p.egress_sip_port) != null ? ref2 : p.sip_port + 10000;
      socket_port = (ref3 = p.socket_port) != null ? ref3 : 5721;
    } else {
      debug('Missing cfg.host or cfg.profiles[profile], not starting.', {
        profile: profile
      });
      return;
    }
    local_server = cfg.host + ":" + ((ref4 = p.ingress_sip_port) != null ? ref4 : p.sip_port);
    client_server = cfg.host + ":" + ((ref5 = p.egress_sip_port) != null ? ref5 : p.sip_port + 10000);
    debug('Using', {
      local_server: local_server,
      client_server: client_server
    });
    Reference = cfg.Reference;
    ev.on('place-call', seem((function(_this) {
      return function*(data) {
        var _id, account, argv, caller, cmd, command, domain, endpoint, endpoint_data, is_remote, my_reference, params, ref6, res, sofia, timezone, xref;
        endpoint = data.endpoint, caller = data.caller, _id = data._id;
        if (data.callee_name == null) {
          data.callee_name = pkg.name;
        }
        if (data.callee_num == null) {
          data.callee_num = data.destination;
        }
        debug('Received place-call', data);
        if (!((_id != null) && _id.match(/^[\w-]+$/))) {
          return;
        }
        endpoint_data = (yield cfg.prov.get("endpoint:" + endpoint)["catch"](function() {
          return null;
        }));
        if (endpoint_data == null) {
          return;
        }
        if (endpoint_data.disabled || endpoint_data.src_disabled) {
          return;
        }
        account = endpoint_data.account, timezone = endpoint_data.timezone;
        domain = endpoint_data.number_domain;
        if (domain == null) {
          return;
        }
        is_remote = (yield cfg.is_remote(domain, [local_server, client_server].join('/'))["catch"](function() {
          return true;
        }));
        if (is_remote) {
          return;
        }
        debug('place-call: Placing call');
        my_reference = new Reference(_id);
        yield my_reference.add_in(["endpoint:" + endpoint, "account:" + account, "number_domain:" + domain]);
        yield my_reference.set_account(account);
        yield my_reference.set_destination(data.destination);
        xref = "xref=" + _id;
        params = make_params({
          session_reference: _id,
          origination_context: context,
          sip_invite_params: xref,
          sip_invite_to_params: xref,
          sip_invite_contact_params: xref,
          sip_invite_from_params: xref,
          'sip_h_X-En': data.endpoint
        });
        sofia = "{" + params + "}sofia/" + sofia_profile + "/sip:" + caller;
        command = "socket(127.0.0.1:" + socket_port + " async full)";
        argv = [sofia, "'&" + command + "'", 'none', context, data.callee_name, data.callee_num, (ref6 = data.call_timeout) != null ? ref6 : ''].join(' ');
        cmd = "originate " + argv;
        if (!(yield elected(_id))) {
          return;
        }
        debug("Calling " + cmd);
        res = (yield cfg.api(cmd)["catch"](function(error) {
          var msg, ref7;
          msg = (ref7 = error.stack) != null ? ref7 : error.toString();
          debug("originate: " + msg);
          return msg;
        }));
        debug("Originate returned", res);
        if (res[0] === '+') {
          debug('caller-connected', _id);
        } else {
          debug.dev('caller-failed', _id);
        }
        return debug('Session state:', data.tags);
      };
    })(this)));
    return ev.on('call-to-conference', seem((function(_this) {
      return function*(data) {
        var _id, account, calling_number, cmd, destination, endpoint, endpoint_data, is_remote, language, my_reference, name, number_data, params, ref6, res, sofia, timezone, xref;
        endpoint = data.endpoint, name = data.name, destination = data.destination, _id = data._id;
        debug('Received call-to-conference', data, local_server);
        if (!((_id != null) && _id.match(/^[\w-]+$/))) {
          return;
        }
        is_remote = (yield cfg.is_remote(name, local_server)["catch"](function() {
          return true;
        }));
        if (is_remote) {
          return;
        }
        endpoint_data = (yield cfg.prov.get("endpoint:" + endpoint)["catch"](function() {
          return null;
        }));
        if (endpoint_data == null) {
          return;
        }
        if (endpoint_data.disabled || endpoint_data.src_disabled) {
          return;
        }
        account = endpoint_data.account, timezone = endpoint_data.timezone;
        number_data = (yield cfg.prov.get("number:" + endpoint)["catch"](function() {
          return {};
        }));
        calling_number = (ref6 = number_data.asserted_number) != null ? ref6 : endpoint.split('@')[0];
        language = data.language;
        if (language == null) {
          language = number_data.language;
        }
        if (language == null) {
          language = endpoint_data.language;
        }
        if (data.timezone != null) {
          if (timezone == null) {
            timezone = data.timezone;
          }
        }
        debug('call-to-conference: Placing call');
        my_reference = new Reference(_id);
        yield my_reference.add_in(["endpoint:" + endpoint, "account:" + account, "number_domain:" + endpoint.number_domain]);
        yield my_reference.set_account(account);
        yield my_reference.set_endpoint(endpoint);
        yield my_reference.set_call_options({
          group_confirm_key: '5',
          group_confirm_file: 'phrase:conference:confirm:5',
          group_confirm_error_file: 'phrase:conference:confirm:5',
          group_confirm_read_timeout: 15000,
          group_confirm_cancel_timeout: false,
          language: language
        });
        xref = "xref:" + _id;
        params = make_params({
          sip_invite_params: xref,
          sip_invite_to_params: xref,
          sip_invite_contact_params: xref,
          sip_invite_from_params: xref,
          origination_caller_id_number: calling_number
        });
        sofia = "{" + params + "}sofia/" + sofia_profile + "/sip:" + destination + "@" + host + ":" + port;
        cmd = "originate " + sofia + " &conference(" + name + "++flags{})";
        if (!(yield elected(_id))) {
          return;
        }
        debug("Calling " + cmd);
        res = (yield cfg.api(cmd)["catch"](function(error) {
          var msg, ref7;
          msg = (ref7 = error.stack) != null ? ref7 : error.toString();
          debug("conference: " + msg);
          return msg;
        }));
        return debug("Conference returned", res);
      };
    })(this)));
  };

  this.notify = function(arg) {
    var cfg, socket;
    cfg = arg.cfg, socket = arg.socket;
    handler(cfg, socket);
    this.register('place-call', 'dial_calls');
    this.register('call-to-conference', 'dial_calls');
    this.configure({
      dial_calls: true
    });
    return debug('Module Ready');
  };

  this.include = seem(function*() {
    var account, destination, options;
    destination = (yield this.reference.get_destination());
    if (destination != null) {
      this.destination = destination;
      yield this.reference.set_destination(null);
      this.session.wait_for_aleg_ack = false;
      this.session.sip_wait_for_aleg_ack = false;
      account = this.reference.get_account();
      if (account != null) {
        yield this["export"]({
          'sip_h_P-Charge-Info': "sip:" + account + "@" + this.cfg.host
        });
      }
    }
    options = (yield this.reference.get_call_options());
    if (options != null) {
      this.session.call_options = options;
    }
    return this.debug('Ready', {
      destination: destination,
      account: account,
      options: options
    });
  });

}).call(this);
