// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, seem;

  seem = require('seem');

  pkg = require('../../package.json');

  this.name = pkg.name + ":middleware:client:setup";

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    var Reference, base, base1, base2, base3, base4, base5, base6, base7, m, our_dialplan, p, ref, ref1, ref2, ref3, ref4, ref5, ref6, reference_in, referred_by, sip_params, sip_profile_carrier, sip_profile_client, sip_refer_to, sip_referred_by;
    if ((base = this.session).context == null) {
      base.context = this.req.variable('origination_context');
    }
    if ((base1 = this.session).context == null) {
      base1.context = this.data['Channel-Context'];
    }
    this.debug('>>>> New call', this.session.context, this.data);
    if (!(m = (ref = this.session.context) != null ? ref.match(/^(\S+)-(ingress|egress|transfer|handled)(?:-(\S+))?$/) : void 0)) {
      this.debug.dev('Malformed context', this.session.context);
      return this.respond('500 Malformed context');
    }
    this.session.profile = m[1];
    this.direction(m[2]);
    if ((base2 = this.session).reference == null) {
      base2.reference = m[3];
    }
    if ((base3 = this.session).reference == null) {
      base3.reference = this.req.variable('session_reference');
    }
    reference_in = (function(_this) {
      return function(name) {
        var base4, v;
        v = _this.req.variable(name);
        if (v == null) {
          return;
        }
        m = v.match(/xref[=:]([\w-]+)/);
        if ((m != null) && (m[1] != null)) {
          return (base4 = _this.session).reference != null ? base4.reference : base4.reference = m[1];
        } else {
          return _this.debug.dev(name + " " + v + " has no xref");
        }
      };
    })(this);
    reference_in('sip_from_params');
    reference_in('sip_to_params');
    reference_in('sip_req_params');
    reference_in('sip_contact_params');
    reference_in('sip_referred_by_params');
    reference_in('sip_h_X-FS-Refer-Params');
    Reference = this.cfg.Reference;
    this.reference = new Reference(this.session.reference);
    this.session.reference = this.reference.id;
    if ((yield this.reference.get_dev_logger())) {
      this.session.dev_logger = true;
    }
    this.notify({
      state: 'incoming-call-client-side'
    });
    sip_profile_client = pkg.name + "-" + this.session.profile + "-egress";
    sip_profile_carrier = pkg.name + "-" + this.session.profile + "-ingress";
    if ((base4 = this.session).sip_profile_client == null) {
      base4.sip_profile_client = sip_profile_client;
    }
    if ((base5 = this.session).sip_profile_carrier == null) {
      base5.sip_profile_carrier = sip_profile_carrier;
    }
    if (this.session.direction === 'ingress') {
      if ((base6 = this.session).sip_profile == null) {
        base6.sip_profile = sip_profile_client;
      }
    } else {
      if ((base7 = this.session).sip_profile == null) {
        base7.sip_profile = sip_profile_carrier;
      }
    }
    this.session.transfer = false;
    this.session.default_transfer_context = [this.session.profile, 'transfer', this.session.reference].join('-');
    if (this.session.direction === 'transfer' || (this.req.variable('transfer_source') != null)) {
      this.session.transfer = true;
      sip_refer_to = this.req.variable('sip_refer_to');
      sip_referred_by = this.req.variable('sip_h_Referred-By');
      if ((sip_refer_to != null) && (sip_referred_by != null)) {
        m = sip_refer_to.match(/sip:(\d+)@/);
        this.debug('refer_to', m[1]);
        this.destination = m[1];
        m = sip_referred_by.match(/sip:(\d+)@/);
        this.debug('referred_by', m[1]);
        referred_by = m[1];
        this.session.wait_for_aleg_ack = false;
        this.session.sip_wait_for_aleg_ack = false;
      }
      this.direction('egress');
    }
    this.session.handled_transfer_context = [this.session.profile, 'handled', this.session.reference].join('-');
    if (this.session.direction === 'handled') {
      this.session.transfer = true;
      this.direction('handled');
    }
    p = (ref1 = this.cfg.profiles) != null ? ref1[this.session.profile] : void 0;
    if (p != null) {
      this.session.local_server = this.cfg.host + ":" + ((ref2 = p.ingress_sip_port) != null ? ref2 : p.sip_port);
      this.session.client_server = this.cfg.host + ":" + ((ref3 = p.egress_sip_port) != null ? ref3 : p.sip_port + 10000);
    } else {
      this.debug.dev('Missing profile', this.session.profile);
    }
    sip_params = "xref=" + this.session.reference;
    our_dialplan = "inline:'socket:127.0.0.1:" + ((ref4 = this.cfg.port) != null ? ref4 : 5702) + " async full'";
    yield this.set({
      session_reference: this.session.reference,
      force_transfer_context: this.session.default_transfer_context
    });
    yield this["export"]({
      session_reference: this.session.reference,
      sip_redirect_profile: this.session.profile,
      sip_redirect_context: this.session.default_transfer_context,
      sip_redirect_dialplan: our_dialplan,
      sip_redirect_contact_params: sip_params,
      sip_invite_params: sip_params,
      sip_invite_to_params: sip_params,
      sip_invite_contact_params: sip_params,
      sip_invite_from_params: sip_params
    });
    this.debug('Ready', {
      reference: this.session.reference,
      call: this.call.uuid,
      session: this.session._id,
      context: this.session.context,
      direction: this.session.direction,
      destination: this.destination,
      source: this.source,
      transfer: this.session.transfer,
      profile: this.session.profile,
      sip_profile: this.session.sip_profile,
      default_transfer_context: this.session.default_transfer_context,
      wait_for_aleg_ack: (ref5 = this.session.wait_for_aleg_ack) != null ? ref5 : null,
      local_server: (ref6 = this.session.local_server) != null ? ref6 : null
    });
  });

}).call(this);
