// Generated by CoffeeScript 1.12.7
(function() {
  var debug, seem;

  this.name = 'huge-play:middleware:dtmf';

  seem = require('seem');

  debug = (require('tangible'))(this.name);

  this.include = seem(function*() {
    var clear, clear_handler, clear_timer, dtmf_buffer, expect, handler, present, timer;
    timer = null;
    handler = null;
    clear_timer = function() {
      debug('clear_timer');
      if (timer != null) {
        clearTimeout(timer);
      }
      return timer = null;
    };
    clear_handler = (function(_this) {
      return function() {
        debug('clear_handler');
        return handler = null;
      };
    })(this);
    dtmf_buffer = '';
    clear = function() {
      var r;
      debug('clear');
      clear_handler();
      clear_timer();
      r = dtmf_buffer;
      dtmf_buffer = '';
      return r;
    };
    expect = (function(_this) {
      return function(min_length, max_length, inter_digit, final) {
        if (max_length == null) {
          max_length = 16;
        }
        if (inter_digit == null) {
          inter_digit = 3 * 1000;
        }
        if (final == null) {
          final = inter_digit;
        }
        _this.debug('expect', min_length, max_length);
        clear_timer();
        return new Promise(function(resolve) {
          var m, set_timer;
          if (m = dtmf_buffer.match(/^([^#]*)#/)) {
            clear();
            resolve(m[1]);
            return;
          }
          if (dtmf_buffer.length >= max_length) {
            resolve(clear());
            return;
          }
          set_timer = function() {
            debug('set_timer');
            clear_timer();
            timer = setTimeout(function() {
              debug('inter-digit timer expired');
              clear_timer();
              if (dtmf_buffer.length >= min_length) {
                resolve(clear());
                return;
              }
              timer = setTimeout(function() {
                debug('final timer expired');
                return resolve(clear());
              }, final);
            }, inter_digit);
          };
          handler = function() {
            debug('handler', dtmf_buffer);
            clear_timer();
            if (m = dtmf_buffer.match(/^([^#]*)#/)) {
              clear();
              resolve(m[1]);
              return;
            }
            if (dtmf_buffer.length >= max_length) {
              resolve(clear());
              return;
            }
            return set_timer();
          };
          set_timer();
        });
      };
    })(this);
    yield this.call.event_json('DTMF');
    this.call.on('DTMF', (function(_this) {
      return function(res) {
        if (dtmf_buffer == null) {
          dtmf_buffer = '';
        }
        dtmf_buffer += res.body['DTMF-Digit'];
        if (typeof handler === "function") {
          handler(dtmf_buffer);
        }
      };
    })(this));
    present = function() {
      return dtmf_buffer.length > 0;
    };
    this.dtmf = {
      clear: clear,
      expect: expect,
      playback: seem((function(_this) {
        return function*(url) {
          if (present()) {
            return;
          }
          yield _this.set({
            playback_terminators: '1234567890#*'
          });
          return (yield _this.action('playback', url));
        };
      })(this)),
      phrase: seem((function(_this) {
        return function*(phrase) {
          if (present()) {
            return;
          }
          yield _this.set({
            playback_terminators: '1234567890#*'
          });
          return (yield _this.action('phrase', phrase));
        };
      })(this))
    };
    return null;
  });

}).call(this);
