// Generated by CoffeeScript 1.12.7
(function() {
  var debug, pkg, qs, request, seem;

  pkg = require('../package.json');

  this.name = pkg.name + ":middleware:prompt";

  debug = (require('tangible'))(this.name);

  request = require('request');

  qs = require('querystring');

  seem = require('seem');

  this.web = function() {
    return this.cfg.versions[pkg.name] = pkg.version;
  };

  this.include = function() {
    var prompt;
    prompt = {};
    prompt.record = seem((function(_this) {
      return function*(file, time_limit) {
        var body, duration, silence_hits, silence_thresh;
        if (time_limit == null) {
          time_limit = 300;
        }
        _this.debug('record', {
          file: file,
          time_limit: time_limit
        });
        silence_thresh = 20;
        silence_hits = 3;
        yield _this.action('set', 'playback_terminators=any');
        yield _this.action('gentones', '%(500,0,800)');
        body = (yield _this.action('record', [file, time_limit, silence_thresh, silence_hits].join(' '))).body;
        duration = body.variable_record_seconds;
        _this.debug('record', {
          duration: duration
        });
        return duration;
      };
    })(this));
    prompt.play_and_get_digits = (function(_this) {
      return function(o) {
        var ref, ref1, ref2, ref3;
        _this.debug('play_and_get_digits', o);
        return _this.action('play_and_get_digits', [o.min, o.max, (ref = o.tries) != null ? ref : 1, o.timeout, (ref1 = o.terminators) != null ? ref1 : '#', o.file, (ref2 = o.invalid_file) != null ? ref2 : 'silence_stream://250', o.var_name, o.regexp, o.digit_timeout, (ref3 = o.transfer_on_failure) != null ? ref3 : ''].join(' '));
      };
    })(this);
    prompt.play = seem(function*(file, o) {
      var body, name, ref;
      if (o == null) {
        o = {};
      }
      o.file = file;
      if (o.min == null) {
        o.min = 1;
      }
      if (o.max == null) {
        o.max = 1;
      }
      if (o.timeout == null) {
        o.timeout = 1000;
      }
      if (o.var_name == null) {
        o.var_name = 'choice';
      }
      if (o.regexp == null) {
        o.regexp = '\\d';
      }
      if (o.digit_timeout == null) {
        o.digit_timeout = 1000;
      }
      body = (yield prompt.play_and_get_digits(o)).body;
      name = "variable_" + o.var_name;
      debug("Got " + body[name] + " for " + name);
      return (ref = body[name]) != null ? ref : null;
    });
    prompt.get_choice = function(file, o) {
      if (o == null) {
        o = {};
      }
      if (o.timeout == null) {
        o.timeout = 15000;
      }
      if (o.digit_timeout == null) {
        o.digit_timeout = 3000;
      }
      return prompt.play(file, o);
    };
    prompt.get_number = function(o) {
      if (o == null) {
        o = {};
      }
      if (o.file == null) {
        o.file = 'phrase:voicemail_enter_id:#';
      }
      if (o.invalid_file == null) {
        o.invalid_file = "phrase:'voicemail_fail_auth'";
      }
      if (o.min == null) {
        o.min = 1;
      }
      if (o.max == null) {
        o.max = 16;
      }
      if (o.var_name == null) {
        o.var_name = 'number';
      }
      if (o.regexp == null) {
        o.regexp = '\\d+';
      }
      if (o.digit_timeout == null) {
        o.digit_timeout = 3000;
      }
      return prompt.get_choice(o.file, o);
    };
    prompt.get_pin = function(o) {
      if (o == null) {
        o = {};
      }
      if (o.file == null) {
        o.file = 'phrase:voicemail_enter_pass:#';
      }
      if (o.min == null) {
        o.min = 4;
      }
      if (o.max == null) {
        o.max = 16;
      }
      if (o.var_name == null) {
        o.var_name = 'pin';
      }
      return prompt.get_number(o);
    };
    prompt.get_new_pin = function(o) {
      if (o == null) {
        o = {};
      }
      if (o.var_name == null) {
        o.var_name = 'new_pin';
      }
      o.invalid_file = 'silence_stream://250';
      return prompt.get_pin(o);
    };
    prompt.goodbye = seem((function(_this) {
      return function*() {
        _this.debug('goodbye');
        yield prompt.phrase('voicemail_goodbye');
        yield _this.action('hangup');
        return _this.debug('goodbye done');
      };
    })(this));
    prompt.phrase = seem((function(_this) {
      return function*(phrase) {
        _this.debug('phrase');
        return (yield _this.action('phrase', phrase));
      };
    })(this));
    prompt.error = seem(function*(id) {
      this.debug('error', {
        id: id
      });
      if (id != null) {
        yield prompt.phrase("spell," + id);
      }
      yield prompt.goodbye();
      return Promise.reject(new Error("error " + id));
    });
    prompt.uri = (function(_this) {
      return function(domain, db, id, file, rev) {
        var host, path, port, ref;
        host = (ref = _this.cfg.web.host) != null ? ref : '127.0.0.1';
        port = _this.cfg.web.port;
        domain = qs.escape(domain);
        db = qs.escape(db);
        id = qs.escape(id);
        rev = qs.escape(rev != null ? rev : 'no-rev');
        file = qs.escape(file);
        path = "/" + domain + "/" + db + "/" + id + "/" + rev + "/" + file;
        return "http://" + host + ":" + port + path;
      };
    })(this);
    this.prompt = prompt;
  };

  this.web = function() {
    var cfg, translators;
    cfg = this.cfg;
    this.translators = translators = {
      'user-db': (function(_this) {
        return function(db, id, file) {
          db = qs.escape(db);
          id = qs.escape(id);
          file = qs.escape(file);
          return {
            base: cfg.userdb_base_uri,
            uri: "/" + db + "/" + id + "/" + file
          };
        };
      })(this),
      'prov': (function(_this) {
        return function(db, id, file) {
          id = qs.escape(id);
          file = qs.escape(file);
          return {
            base: cfg.provisioning,
            uri: id + "/" + file
          };
        };
      })(this),
      'master-prov': (function(_this) {
        return function(db, id, file) {
          var masters;
          id = qs.escape(id);
          file = qs.escape(file);
          masters = cfg.prov_master_admin;
          if (masters != null) {
            if (typeof masters === 'string') {
              masters = [masters];
            }
          }
          return {
            base: masters[0],
            uri: id + "/" + file
          };
        };
      })(this)
    };
    this.get('/:domain/:db/:id/:rev/:file', function() {
      var base, proxy, ref, translator, uri;
      translator = translators[this.params.domain];
      if (translator == null) {
        this.next('Invalid domain');
        return;
      }
      ref = translator(this.params.db, this.params.id, this.params.file), base = ref.base, uri = ref.uri;
      proxy = request.get({
        baseUrl: base,
        uri: uri,
        followRedirects: false,
        maxRedirects: 0
      });
      this.request.pipe(proxy).on('error', (function(_this) {
        return function(error) {
          debug("GET " + uri + " : " + error);
          _this.next("GET " + uri + " : " + error);
        };
      })(this));
      proxy.pipe(this.response);
    });
    return this.put('/:domain/:db/:id/:rev/:file', function() {
      var base, proxy, ref, translator, uri;
      translator = translators[this.params.domain];
      if (translator == null) {
        this.next('Invalid domain');
        return;
      }
      ref = translator(this.params.db, this.params.id, this.params.file), base = ref.base, uri = ref.uri;
      proxy = request.put({
        baseUrl: base,
        uri: uri,
        qs: {
          rev: this.params.rev
        },
        followRedirects: false,
        maxRedirects: 0,
        timeout: 120
      });
      this.request.pipe(proxy).on('error', (function(_this) {
        return function(error) {
          var ref1;
          debug("GET " + uri + " rev " + _this.params.rev + " : " + ((ref1 = error.stack) != null ? ref1 : error));
          try {
            _this.res.end();
          } catch (error1) {}
        };
      })(this));
      proxy.pipe(this.response);
    });
  };

}).call(this);
