// Generated by CoffeeScript 1.12.7
(function() {
  var EventEmitter, FS, LRU, Moment, Redis, RedisInterface, Reference, assert, debug, minutes, nimble, now, pkg, seconds, seem,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    slice = [].slice;

  seem = require('seem');

  nimble = require('nimble-direction');

  pkg = require('../package.json');

  EventEmitter = require('events');

  Moment = require('moment-timezone');

  this.name = pkg.name + ":middleware:setup";

  assert = require('assert');

  FS = require('esl');

  LRU = require('lru-cache');

  Redis = require('ioredis');

  RedisInterface = require('normal-key/interface');

  Reference = require('./reference');

  debug = (require('tangible'))(this.name);

  seconds = 1000;

  minutes = 60 * seconds;

  now = function(tz) {
    if (tz == null) {
      tz = 'UTC';
    }
    return Moment().tz(tz).format();
  };

  this.config = seem(function*() {
    yield nimble(this.cfg);
    return assert(this.cfg.prov != null, 'Nimble did not inject cfg.prov');
  });

  this.server_pre = seem(function*() {
    var EVENT_NAME, HugePlayReference, UNIQUE_ID, _api, _client, base, call_timeout, default_client, is_remote_cache, make_a_redis, monitor_client, monitored_events, redis_interface;
    yield nimble(this.cfg);
    assert(this.cfg.prov != null, 'Nimble did not inject cfg.prov');
    make_a_redis = (function(_this) {
      return function(label, config) {
        var a_redis;
        a_redis = Redis.createClient(config);
        a_redis.on('error', function(error) {
          var ref, ref1;
          return debug(label + ": " + error.command + " " + ((ref = error.args) != null ? ref.join(' ') : void 0) + ": " + ((ref1 = error.stack) != null ? ref1 : error));
        });
        a_redis.on('ready', function() {
          return debug(label + ": ready");
        });
        a_redis.on('connect', function() {
          return debug(label + ": connect");
        });
        a_redis.on('reconnecting', function() {
          return debug(label + ": reconnecting");
        });
        a_redis.on('end', function() {
          return debug(label + ": end");
        });
        a_redis.on('warning', function() {
          return debug(label + ": warning");
        });
        return a_redis;
      };
    })(this);
    if (this.cfg.redis != null) {
      this.cfg.global_redis_client = make_a_redis('global redis', this.cfg.redis);
    }
    if (this.cfg.local_redis != null) {
      this.cfg.local_redis_client = make_a_redis('local redis', this.cfg.local_redis);
    }
    call_timeout = 8 * 3600;
    redis_interface = new RedisInterface(this.cfg.global_redis_client, call_timeout);
    HugePlayReference = (function(superClass) {
      extend(HugePlayReference, superClass);

      function HugePlayReference() {
        return HugePlayReference.__super__.constructor.apply(this, arguments);
      }

      HugePlayReference.prototype["interface"] = redis_interface;

      return HugePlayReference;

    })(Reference);
    this.cfg.Reference = HugePlayReference;
    if ((base = this.cfg).period_of == null) {
      base.period_of = function(stamp, timezone) {
        if (stamp == null) {
          stamp = new Date();
        }
        if (timezone == null) {
          timezone = 'UTC';
        }
        return Moment.tz(stamp, timezone).format('YYYY-MM');
      };
    }
    is_remote_cache = LRU({
      max: 2000,
      maxAge: 1 * minutes
    });
    this.cfg.is_remote = seem((function(_this) {
      return function*(name, local_server) {
        var first_time, key, server;
        if (name == null) {
          return null;
        }
        key = "server for " + name;
        if (_this.cfg.global_redis_client == null) {
          debug.dev('is_remote: Missing global redis');
          return null;
        }
        if (local_server == null) {
          server = is_remote_cache.get(name);
          if (server === void 0) {
            server = (yield _this.cfg.global_redis_client.get(key)["catch"](function(error) {
              var ref;
              debug.ops("error " + ((ref = error.stack) != null ? ref : error));
              return null;
            }));
            is_remote_cache.set(name, server);
          }
          switch (server != null ? server.substring(0, _this.cfg.host.length) : void 0) {
            case null:
              return null;
            case _this.cfg.host:
              return false;
            default:
              return server;
          }
        }
        server = local_server;
        first_time = (yield _this.cfg.global_redis_client.setnx(key, server)["catch"](function(error) {
          var ref;
          debug.ops("error " + ((ref = error.stack) != null ? ref : error) + ", forcing local server");
          return 1;
        }));
        if (!first_time) {
          server = (yield _this.cfg.global_redis_client.get(key)["catch"](function(error) {
            var ref;
            debug.ops("error " + ((ref = error.stack) != null ? ref : error));
            return null;
          }));
        }
        debug('Checking for local handling', server, local_server);
        switch (server) {
          case null:
            debug.ops('Redis failed');
            return null;
          case local_server:
            debug('Handling is local');
            return false;
          default:
            debug('Handling is remote');
            return server;
        }
      };
    })(this));
    _client = (function(_this) {
      return function() {
        return new Promise(function(resolve) {
          var client, error, ref;
          try {
            client = FS.client(function() {
              return resolve(this);
            });
            client.keepConnected((ref = _this.cfg.socket_port) != null ? ref : 5722, '127.0.0.1');
          } catch (error1) {
            error = error1;
            debug('_client: error', error);
            resolve(null);
          }
        });
      };
    })(this);
    this.cfg.uuid_client = seem(function*(uuid) {
      var client;
      client = (yield _client());
      yield client.send("myevents " + uuid + " json");
      yield client.event_json('ALL');
      yield client.linger();
      return client;
    });
    default_client = null;
    _api = seem(function*(cmd) {
      var res;
      if (default_client == null) {
        default_client = (yield _client());
      }
      return res = (yield default_client.bgapi(cmd));
    });
    this.cfg.api = seem((function(_this) {
      return function*(cmd) {
        var ref, res;
        debug('api', cmd);
        res = (yield _api(cmd));
        return (ref = res != null ? res.body : void 0) != null ? ref : null;
      };
    })(this));
    this.cfg.api.send = _api;
    this.cfg.api.create = _client;
    this.cfg.api.truthy = (function(_this) {
      return function(cmd) {
        var on_failure, on_success;
        debug('api.truthy', cmd);
        on_success = function(res) {
          debug('api.truthy', cmd, res);
          switch (false) {
            case res.uuid == null:
              return res.uuid;
            case res.body !== 'true':
              return true;
            case res.body !== 'false':
              return false;
            case res.body[0] !== '-':
              return false;
            default:
              return true;
          }
        };
        on_failure = function(error) {
          debug('api.truthy', cmd, error);
          return false;
        };
        return _api(cmd).then(on_success, on_failure);
      };
    })(this);
    UNIQUE_ID = 'Unique-ID';
    EVENT_NAME = 'Event-Name';
    monitor_client = null;
    monitored_events = {};
    this.cfg.api.monitor = seem(function*(id, events) {
      var ev, listener;
      debug('api.monitor: start', {
        id: id,
        events: events
      });
      if (monitor_client == null) {
        monitor_client = (yield _client());
      }
      debug('api.monitor: filtering', id);
      yield monitor_client.filter(UNIQUE_ID, id);
      ev = new EventEmitter();
      ev.setMaxListeners(200);
      listener = function(msg) {
        var msg_ev, msg_id;
        if ((msg != null ? msg.body : void 0) == null) {
          return;
        }
        msg_id = msg.body[UNIQUE_ID];
        msg_ev = msg.body[EVENT_NAME];
        debug('api.monitor received', msg_id, msg_ev);
        if (msg_id === id && indexOf.call(events, msg_ev) >= 0) {
          return ev != null ? ev.emit(msg_ev, msg) : void 0;
        }
      };
      yield seem(function*() {
        var event, i, len, results;
        results = [];
        for (i = 0, len = events.length; i < len; i++) {
          event = events[i];
          monitor_client.on(event, listener);
          if (monitored_events[event] == null) {
            monitored_events[event] = 0;
          }
          if (monitored_events[event]++ === 0) {
            debug('Adding event json for', event);
            results.push((yield monitor_client.event_json(event)));
          } else {
            results.push(void 0);
          }
        }
        return results;
      })();
      ev.end = seem(function*() {
        var event, i, len;
        if (ev == null) {
          debug('api.monitor.end: called more than once (ignored)', {
            id: id,
            events: events
          });
          return;
        }
        debug('api.monitor.end', {
          id: id,
          events: events
        });
        yield monitor_client.filter_delete(UNIQUE_ID, id);
        for (i = 0, len = events.length; i < len; i++) {
          event = events[i];
          monitor_client.removeListener(event, listener);
          if (--monitored_events[event] === 0) {
            debug('api.monitor.end: nixevent', event);
            yield monitor_client.nixevent(event);
          }
        }
        ev.removeAllListeners();
        ev = null;
        return debug('api.monitor.end: done');
      });
      debug('api.monitor: ready', {
        id: id,
        events: events
      });
      return ev;
    });
  });

  this.web = function() {
    return this.cfg.versions[pkg.name] = pkg.version;
  };

  this.notify = function() {
    this.on_connexion = (function(_this) {
      return function(init) {
        _this.socket.on('welcome', init);
        return init();
      };
    })(this);
    this.register = (function(_this) {
      return function(event, default_room) {
        if (default_room == null) {
          default_room = null;
        }
        return _this.on_connexion(function() {
          debug('Register', {
            event: event,
            default_room: default_room
          });
          return _this.socket.emit('register', {
            event: event,
            default_room: default_room
          });
        });
      };
    })(this);
    this.socket.on('configured', (function(_this) {
      return function(data) {
        return debug('Socket configured', data);
      };
    })(this));
    this.configure = (function(_this) {
      return function(options) {
        return _this.on_connexion(function() {
          debug('Configure', options);
          return _this.socket.emit('configure', options);
        });
      };
    })(this);
    this.socket.on('connect', (function(_this) {
      return function() {
        return debug.ops('connect');
      };
    })(this));
    this.socket.on('connect_error', (function(_this) {
      return function() {
        return debug.ops('connect_error');
      };
    })(this));
    this.socket.on('disconnect', (function(_this) {
      return function() {
        return debug.ops('disconnect');
      };
    })(this));
  };

  this.include = function(ctx) {
    var _bus, k, ref, v;
    _bus = new EventEmitter();
    ref = {
      on: function(ev, cb) {
        return _bus.on(ev, cb);
      },
      once: function(ev, cb) {
        return _bus.once(ev, cb);
      },
      emit: function(ev, data) {
        return _bus.emit(ev, data);
      },
      statistics: this.cfg.statistics,
      sleep: function(timeout) {
        return new Promise(function(resolve) {
          return setTimeout(resolve, timeout);
        });
      },
      direction: function(direction) {
        this.session.direction = direction;
        this.emit('direction', direction);
        return this.report({
          event: 'direction',
          direction: direction
        });
      },
      _in: seem(function*(_in) {
        var i, len, push_in, ref, ref1, ref2, ref3, ref4, ref5, tag, tags;
        if (_in == null) {
          _in = [];
        }
        push_in = function(room) {
          if ((room == null) || indexOf.call(_in, room) >= 0) {
            return;
          }
          return _in.push(room);
        };
        push_in((ref = this.session.endpoint) != null ? ref._id : void 0);
        if (((ref1 = this.session.number) != null ? ref1.endpoint : void 0) != null) {
          push_in(['endpoint', (ref2 = this.session.number) != null ? ref2.endpoint : void 0].join(':'));
        }
        push_in((ref3 = this.session.number) != null ? ref3._id : void 0);
        push_in((ref4 = this.session.e164_number) != null ? ref4._id : void 0);
        if (((ref5 = this.session.number_domain_data) != null ? ref5.dialplan : void 0) === 'centrex') {
          push_in(this.session.number_domain_data._id);
        }
        if (this.reference != null) {
          tags = (yield this.reference.get_in()["catch"](function() {
            return [];
          }));
          for (i = 0, len = tags.length; i < len; i++) {
            tag = tags[i];
            push_in(tag);
          }
        }
        return _in;
      }),
      report: seem(function*(report) {
        var ref;
        if (!((this.call != null) && (this.session != null))) {
          debug.dev('report: improper environment');
          return false;
        }
        if (report.old_state == null) {
          report.old_state = this.session.state;
        }
        if (report.state != null) {
          this.session.state = report.state;
        }
        if (report.timezone == null) {
          report.timezone = this.session.timezone;
        }
        if (report.timestamp == null) {
          report.timestamp = now(report.timezone);
        }
        report.now = Date.now();
        report._in = (yield this._in(report._in));
        if (report.host == null) {
          report.host = this.cfg.host;
        }
        if (report.type == null) {
          report.type = 'report';
        }
        if (report.source == null) {
          report.source = this.source;
        }
        if (report.destination == null) {
          report.destination = this.destination;
        }
        if (report.direction == null) {
          report.direction = this.session.direction;
        }
        if (report.dialplan == null) {
          report.dialplan = this.session.dialplan;
        }
        if (report.country == null) {
          report.country = this.session.country;
        }
        if (report.number_domain == null) {
          report.number_domain = this.session.number_domain;
        }
        if (report.number_domain_dialplan == null) {
          report.number_domain_dialplan = (ref = this.session.number_domain_data) != null ? ref.dialplan : void 0;
        }
        if (report.agent == null) {
          report.agent = this.session.agent;
        }
        if (report.agent_name == null) {
          report.agent_name = this.session.agent_name;
        }
        report.call = this.call.uuid;
        report.session = this.session._id;
        report.reference = this.session.reference;
        report.report_type = 'in-call';
        this.cfg.statistics.emit('report', report);
        return true;
      }),
      notify: function(report) {
        report._notify = true;
        return this.report(report);
      },
      set: seem(function*(name, value) {
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          yield this.res.set(name, value);
          return;
        }
        for (k in name) {
          if (!hasProp.call(name, k)) continue;
          v = name[k];
          yield this.res.set(k, v);
        }
      }),
      unset: seem(function*(name) {
        var i, len;
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          yield this.res.set(name, null);
          return;
        }
        for (i = 0, len = name.length; i < len; i++) {
          k = name[i];
          yield this.res.set(k, null);
        }
      }),
      "export": seem(function*(name, value) {
        if (name == null) {
          return;
        }
        if (typeof name === 'string') {
          yield this.res["export"](name, value);
          return;
        }
        for (k in name) {
          if (!hasProp.call(name, k)) continue;
          v = name[k];
          yield this.res["export"](k, v);
        }
      }),
      respond: function(response) {
        var base, ref;
        if ((ref = this.statistics) != null) {
          ref.add(['immediate-response', response]);
        }
        this.notify({
          state: 'immediate-response',
          response: response
        });
        if ((base = this.session).first_response_was == null) {
          base.first_response_was = response;
        }
        this.direction('responded');
        if (this.session.alternate_response != null) {
          return this.session.alternate_response(response);
        } else {
          return ctx.action('respond', response);
        }
      },
      sofia_string: seem(function*(number, extra_params) {
        var destination, id, number_data, params, to_uri;
        if (extra_params == null) {
          extra_params = [];
        }
        debug('sofia_string', number, extra_params);
        id = "number:" + number + "@" + this.session.number_domain;
        number_data = (yield this.cfg.prov.get(id)["catch"](function(error) {
          var ref;
          debug.ops(id + " " + ((ref = error.stack) != null ? ref : error));
          return {};
        }));
        if (number_data.number == null) {
          return '';
        }
        destination = number_data.number.split('@')[0];
        to_uri = "sip:" + number_data.endpoint;
        if (!to_uri.match(/@/)) {
          to_uri = "sip:" + destination + "@" + this.cfg.ingress_target;
        }
        if (number_data.endpoint_via != null) {
          extra_params.push("sip_network_destination=" + number_data.endpoint_via);
        }
        params = slice.call(extra_params).concat(["sip_h_X-En=" + number_data.endpoint]);
        return "[" + (params.join(',')) + "]sofia/" + this.session.sip_profile + "/" + to_uri;
      }),
      validate_local_number: seem(function*() {
        var base, base1, dst_number;
        dst_number = this.destination + "@" + this.session.number_domain;
        this.session.number = (yield this.cfg.prov.get("number:" + dst_number)["catch"](function(error) {
          return {
            disabled: true,
            error: error
          };
        }));
        yield this.reference.add_in(this.session.number._id);
        yield this.user_tags(this.session.number.tags);
        if (this.session.number.timezone != null) {
          if ((base = this.session).timezone == null) {
            base.timezone = this.session.number.timezone;
          }
        }
        if (this.session.number.music != null) {
          if ((base1 = this.session).music == null) {
            base1.music = this.session.number.music;
          }
        }
        if (this.session.number.error != null) {
          this.debug.dev("Could not locate destination number " + dst_number);
          this.notify({
            state: 'invalid-local-number',
            number: this.session.number._id
          });
          yield this.respond('486 Not Found');
          return;
        }
        this.debug("validate_local_number: Got dst_number " + dst_number, this.session.number);
        if (this.session.number.disabled) {
          this.debug.ops("Number " + dst_number + " is disabled");
          this.notify({
            state: 'disabled-local-number',
            number: this.session.number._id
          });
          yield this.respond('486 Administratively Forbidden');
          return;
        }
        this.session.endpoint_name = this.session.number.endpoint;
        yield this.reference.set_endpoint(this.session.number.endpoint);
        yield this.reference.add_in("endpoint:" + this.session.number.endpoint);
        yield this.reference.set_account(this.session.number.account);
        yield this.reference.add_in("account:" + this.session.number.account);
        this.report({
          state: 'validated-local-number',
          number: this.session.number._id,
          endpoint: this.session.endpoint_name,
          account: this.session.number.account
        });
        return dst_number;
      }),
      global_redis: this.cfg.global_redis_client,
      local_redis: this.cfg.local_redis_client,
      tag: seem(function*(tag) {
        if (tag != null) {
          yield this.reference.add_tag(tag);
          return this.report({
            event: 'tag',
            tag: tag
          });
        }
      }),
      user_tag: seem(function*(tag) {
        if (tag != null) {
          yield this.reference.add_tag("user-tag:" + tag);
          return this.report({
            event: 'user-tag',
            tag: tag
          });
        }
      }),
      user_tags: seem(function*(tags) {
        var i, len, results, tag;
        if (tags == null) {
          return;
        }
        results = [];
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          results.push((yield this.user_tag(tag)));
        }
        return results;
      }),
      has_tag: seem(function*(tag) {
        return (tag != null) && (yield this.reference.has_tag(tag));
      }),
      has_user_tag: seem(function*(tag) {
        return (tag != null) && (yield this.has_tag("user-tag:" + tag));
      }),
      clear_call_center_tags: seem(function*() {
        var i, len, tag, tags;
        tags = (yield this.reference.tags());
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          if (tag === 'broadcast' || tag.match(/^(skill|priority|queue):/)) {
            yield this.reference.del_tag(tag);
          }
        }
        return null;
      }),
      clear_user_tags: seem(function*() {
        var i, len, tag, tags;
        tags = (yield this.reference.tags());
        for (i = 0, len = tags.length; i < len; i++) {
          tag = tags[i];
          if (tag.match(/^user-tag:/)) {
            yield this.reference.del_tag(tag);
          }
        }
        return null;
      }),
      record_call: function(name) {
        var keep_recording;
        if (this.cfg.recording_uri == null) {
          this.debug.dev('No recording_uri, call will not be recorded.');
          return false;
        }
        keep_recording = seem((function(_this) {
          return function*() {
            var last_uri, outcome, still_running, uri;
            _this.report({
              event: 'recording'
            });
            uri = (yield _this.cfg.recording_uri(name));
            _this.debug('Recording', _this.call.uuid, uri);
            outcome = (yield _this.cfg.api("uuid_record " + _this.call.uuid + " start " + uri));
            _this.debug('Recording', _this.call.uuid, uri, outcome);
            last_uri = uri;
            still_running = true;
            _this.call.once('CHANNEL_HANGUP_COMPLETE', function() {
              return still_running = false;
            });
            while (still_running) {
              yield _this.sleep(29 * minutes);
              uri = (yield _this.cfg.recording_uri(name));
              _this.debug('Recording next segment', _this.call.uuid, uri);
              yield _this.cfg.api("uuid_record " + _this.call.uuid + " start " + uri);
              _this.report({
                event: 'recording'
              });
              yield _this.sleep(1 * minutes);
              _this.debug('Stopping previous segment', _this.call.uuid, last_uri);
              yield _this.cfg.api("uuid_record " + _this.call.uuid + " stop " + last_uri);
              last_uri = uri;
            }
          };
        })(this));
        keep_recording()["catch"]((function(_this) {
          return function(error) {
            var ref;
            return _this.debug("record_call: " + ((ref = error.stack) != null ? ref : error));
          };
        })(this));
        this.debug('Going to record', name);
        return true;
      }
    };
    for (k in ref) {
      if (!hasProp.call(ref, k)) continue;
      v = ref[k];
      ctx[k] = v;
    }
  };

}).call(this);
